// IplUtil.cpp: IplUtil NX̃Cve[V
// IPLC[W̃[eBeBTu[`W
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "math.h"
//#include "tms2avi.h"
#include "IplUtil.h"
#include "peg.h"
#include "TARGA.H"
//#include "PintCircle.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

enum {
	cpu_legacy=0, cpu_mmx=(1<<0),
	cpu_3dnow=(1<<1), cpu_e3dnow=(1<<2),
	cpu_sse=(1<<3), cpu_sse2=(1<<4),
};

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////
IplUtil::IplUtil(COutMsg* p_msg)
{
	m_msg=p_msg;
	m_CPU=CPU(); // MMX,SSE͎g邩H
	TRACE("CPU=%x\n",m_CPU);
}

IplUtil::IplUtil()
{
	IplUtil(NULL);
}

IplUtil::~IplUtil()
{

}

// C[W̃`lvalue
// `lSŒȂ̂Œ
// value = 0`100% ... Zx
void IplUtil::MulAlpha(IplImage * img, float value)
{
	char errmsg[256];
	TRACE("MulAlpha() value=%f\n", value);
	if(value >= 100 || value < 0){
		// 100%Ȃ牽ȂBsȒlȂ牽ȂB
		return;
	}

	if(img->nChannels < 4){
		sprintf(errmsg, "MulAlpha() C[W`lĂ܂ nCannels=%d\n", img->nChannels);
		OutMsg(errmsg);
		return;
	}

	long max;
	switch(img->depth){
	case IPL_DEPTH_8U:
		max=255;
		break;
	case IPL_DEPTH_16U:
		// 16rbg[h
		max=65535;
		break;
	default:
		sprintf(errmsg,"MulAlpha() C[W[xsłdepth=%d\n", img->depth);
		OutMsg(errmsg);
		return;
	}

	int iv = (int)(max*value/100 + 0.5);
	TRACE("MulAlpha:max=%d value=%f, intv=%d\n",max,value,iv);
	IplROI *roi, *save_roi;
	save_roi=img->roi;
	roi = iplCreateROI(4, 0, 0, img->width, img->height); //4Ԗڂ̃`l(=)ɃtH[JX
	img->roi=roi;
	iplMultiplySScale(img, img, iv); // ŃG[ɂȂĂB
	img->roi=save_roi; // NULL܂͌̒l
	iplDeleteROI(roi);
	TRACE("MulAlpha done\n");
	return;
}

// w肳ꂽlŖ߂
void IplUtil::FillAlpha(IplImage * img, int value)
{
	char errmsg[256];
	if(img->nChannels < 4){
		sprintf(errmsg,"FillAlpha() C[W`lĂ܂ nCannels=%d\n", img->nChannels);
		OutMsg(errmsg);
		return;
	}

	IplROI *roi, *save_roi;
	save_roi=img->roi;
	roi = iplCreateROI(4, 0, 0, img->width, img->height); //4Ԗڂ̃`l(=)ɃtH[JX
	img->roi=roi;
	iplSet(img, (int)(value));
	img->roi=save_roi; // NULL܂͌̒l
	iplDeleteROI(roi);

	return;
}

//At@`ltC[WAt@`lȂDIB
// wiF͍
void IplUtil::iplAlphaConvertToDIB(IplImage *img, BITMAPINFOHEADER *dib, unsigned char* dibtop, int dither, int paletteConversion)
{
	TRACE("IMG x=%d y=%d, DIB X=%d y=%d\n",img->width,img->height,dib->biWidth,dib->biHeight);
	int loopx, loopy;
	loopx = __min(img->width, dib->biWidth);
	loopy = __min(img->height,dib->biHeight);

	//char* dibtop=(char*)dib+sizeof(BITMAPINFOHEADER);
	iplPreMultiplyAlpha (img, -1); // lFɔf

	if(img->depth != IPL_DEPTH_8U){
		// 8bit[hȊOȂ8bitɌF ConvertToDIBgăfBUB

	}else{
		int wimage_rowbytes = ((24 * dib->biWidth ) + 31) / 32 * 4; // DIB̉oCg
		int rimage_rowbytes = img->widthStep; // IPLImagẻoCg
		for(int y=0; y<loopy; y++){
			unsigned char* wpixel=(unsigned char*)(dibtop+(loopy-1-y)*wimage_rowbytes); 
			unsigned char* rpixel=(unsigned char*)(img->imageData +y *rimage_rowbytes);
			for(int x=0; x<loopx; x++){
				*wpixel++ = *rpixel++;
				*wpixel++ = *rpixel++;
				*wpixel++ = *rpixel++;
				rpixel++;
			}
		}
	}
	return;
}

// tJ[{At@tIPLC[W쐬
// m_depthF̐[x
IplImage* IplUtil::AllocIpl(CSize size,int p_depth)
{
	int   width = size.cx;
	int   height= size.cy;
	return AllocIpl(width, height, p_depth);
}

IplImage* IplUtil::AllocIpl(int p_width, int p_height, int p_depth)
{
	// ȉCreateImageHeader̃p[^ `lt24bit摜
	int   nChannels = 4; //C[W̃`l.ł͂S
	int   alphaChannel = 4; //`l͉Ԗڂ̃`lBł͂SԖ
	//int     depth = IPL_DEPTH_8U; //e`l͉rbgBł͂Wrbg
	char* colormodel="RGBA"; // J[f"RGB","GRAY","MSI"
	char* channelSeq="BGRA"; // `l̕т̏(BMPɂ킹)
	int   dataOrder=IPL_DATA_ORDER_PIXEL;
	//int     dataOrder=IPL_DATA_ORDER_PLANE;
	int   origin=IPL_ORIGIN_TL; //f[^̕ѕ TL͍ォn܂.BLȂ獶n܂(BMPƓ) *ȂATLɂȂC...Ver2.1ł́B
	// int     align=IPL_ALIGN_DWORD;
	int   align=IPL_ALIGN_QWORD; // Ver1ł̓T|[gĂȂ̂ŗv
	//int   width;
	//int   height;
	IplROI* roi=NULL; // ROI͎gȂ
	IplImage* maskROI=NULL; // Ver2.0p̃}XN
	void* imageId=NULL; // gȂ
	IplTileInfo* tileInfo=NULL; //gȂ
	IplImage* retimg;

	TRACE("AllocIpl(). x=%d y=%d depth=%d\n",p_width, p_height, p_depth);
	if(p_width<=0 || p_height<=0){
		char errmsg[256];
		sprintf(errmsg, "AllocIpl:sȃTCYw肳܂Bwidth=%d height=%d",p_width, p_height);
		OutMsg(errmsg);
		retimg=NULL;
	}else{
		retimg = iplCreateImageHeader(
			nChannels,  alphaChannel, p_depth,
			colormodel, channelSeq,   dataOrder,
			origin,     align,
			p_width,    p_height,roi, maskROI,
			imageId,    tileInfo);
		if(retimg != NULL){	
			iplAllocateImage(retimg, 0, 0); // Ȃ
			if(retimg == NULL){
				OutMsg("AllocIpl:f[^̈mۂɎs܂");
			}
		}else{
			OutMsg("AllocIpl:wb_쐬Ɏs܂");
			iplDeallocate(retimg, IPL_IMAGE_HEADER);
			retimg=NULL;
		}
	}
	return retimg;	
}

IplImage* IplUtil::AllocIplGray(int p_width, int p_height, int p_depth)
{
	int   nChannels = 1; //C[W̃`l.
	int   alphaChannel = 1; //`l͉Ԗڂ̃`lBł͂SԖ
	//int     depth = IPL_DEPTH_8U; //e`l͉rbgBł͂Wrbg
	char* colormodel="GRAY"; // J[f"RGB","GRAY","MSI"
	char* channelSeq="GRAY"; // `l̕т̏(BMPɂ킹)
	int   dataOrder=IPL_DATA_ORDER_PIXEL;
	//int     dataOrder=IPL_DATA_ORDER_PLANE;
	int   origin=IPL_ORIGIN_TL; //f[^̕ѕ TL͍ォn܂.BLȂ獶n܂(BMPƓ) *ȂATLɂȂC...Ver2.1ł́B
	// int     align=IPL_ALIGN_DWORD;
	int   align=IPL_ALIGN_QWORD; // Ver1ł̓T|[gĂȂ̂ŗv
	//int   width;
	//int   height;
	IplROI* roi=NULL; // ROI͎gȂ
	IplImage* maskROI=NULL; // Ver2.0p̃}XN
	void* imageId=NULL; // gȂ
	IplTileInfo* tileInfo=NULL; //gȂ
	IplImage* retimg;
	CString errmsg;

	TRACE("AllocIplGray(). x=%d y=%d depth=%d\n",p_width, p_height, p_depth);
	if(p_width<0 || p_height<0){
		char errmsg[256];
		sprintf(errmsg,"AllocIplGray:sȃTCYw肳܂Bwidth=%d height=%d depth=%d",p_width,p_height,p_depth);
		OutMsg(errmsg);
		retimg=NULL;
	}else{
		retimg = iplCreateImageHeader(
			nChannels,  alphaChannel, p_depth,
			colormodel, channelSeq,   dataOrder,
			origin,     align,
			p_width,    p_height,roi, maskROI,
			imageId,    tileInfo);
		if(retimg != NULL){	
			iplAllocateImage(retimg, 0, 0); // Ȃ
		}else{
			CString errmsg = "AllocIplGray:C[Ẅ̊mۂɎs܂";
			TRACE(errmsg);
			iplDeallocate(retimg, IPL_IMAGE_HEADER);
			retimg=NULL;
		}
	}
	return retimg;	
}

// YUV{At@tIPLC[W쐬
// m_depthF̐[x
IplImage* IplUtil::AllocIplYUV(int p_width, int p_height, int p_depth)
{
	CSize s(p_width, p_height);
	return AllocIplYUV(s, p_depth);
}

IplImage* IplUtil::AllocIplYUV(CSize size,int p_depth)
{
	// ȉCreateImageHeader̃p[^ `lt24bit摜
	int   nChannels = 4; //C[W̃`l.ł͂S
	int   alphaChannel = 4; //`l͉Ԗڂ̃`lBł͂SԖ
	//int     depth = IPL_DEPTH_8U; //e`l͉rbgBł͂Wrbg
	char* colormodel="YUV"; // J[f"RGB","GRAY","MSI"
	char* channelSeq="YUV"; // `l̕т̏(BMPɂ킹)
	int   dataOrder=IPL_DATA_ORDER_PIXEL;
	//int     dataOrder=IPL_DATA_ORDER_PLANE;
	int   origin=IPL_ORIGIN_TL; //f[^̕ѕ TL͍ォn܂.BLȂ獶n܂(BMPƓ) *ȂATLɂȂC...Ver2.1ł́B
	// int     align=IPL_ALIGN_DWORD;
	int   align=IPL_ALIGN_QWORD; // Ver1ł̓T|[gĂȂ̂ŗv
	int   width = size.cx;
	int   height=size.cy;
	IplROI* roi=NULL; // ROI͎gȂ
	IplImage* maskROI=NULL; // Ver2.0p̃}XN
	void* imageId=NULL; // gȂ
	IplTileInfo* tileInfo=NULL; //gȂ
	IplImage* retimg;
	CString errmsg;

	TRACE("AllocIpl(). cx=%d cy=%d\n",size.cx, size.cy);
	if(size.cx<0 || size.cy<0){
		char errmsg[256];
		sprintf(errmsg,"AllocIplYUV:sȃTCYw肳܂Bwidth=%d height=%d depth=%d",size.cx, size.cy,p_depth);
		OutMsg(errmsg);
		retimg=NULL;
	}else{
		retimg = iplCreateImageHeader(
			nChannels,  alphaChannel, p_depth,
			colormodel, channelSeq,   dataOrder,
			origin,     align,
			width,      height,roi, maskROI,
			imageId,    tileInfo);
		if(retimg != NULL){	
			iplAllocateImage(retimg, 0, 0); // Ȃ
		}else{
			CString errmsg = "AllocIpl:C[Ẅ̊mۂɎs܂";
			TRACE(errmsg);
			iplDeallocate(retimg, IPL_IMAGE_HEADER);
			retimg=NULL;
		}
	}
	return retimg;	
}

// src1src2e퍇B
// (dst)pieceɃI[o[bv
// src1 .. 
// src2 ..  ... ωȂƁB
// dst .. src1ƓAhXŎgB܂Aʂsrc1ɓ
void IplUtil::Overlap(IplImage * srcA, IplImage * srcB, IplImage * dst, int mode)
{
	TRACE("Overlap start. mode=%d\n", mode);
	// Iɂ͑Ή邪cB
	if(srcA != dst){
		OutMsg("Overlap:srcAdstႢ܂B");
		return;
	}

	switch(mode){
	case Cpeg::MODE_NORM:
		// Ȃ
		TRACE("Overlap:NORMAL(ʏ)\n");
		break;

	case Cpeg::MODE_ADD:
		// Z
		TRACE("Overlap:Z\n");
		iplAdd(srcA, srcB, dst);
		break;

	case Cpeg::MODE_MUL:
		// Z
		TRACE("Overlap:Z\n");
		iplMultiplyScale(srcA, srcB, dst);
		break;

	case Cpeg::MODE_AND:
		// AND
		TRACE("Overlap:AND\n");
		iplAnd(srcA, srcB, dst);
		break;

	case Cpeg::MODE_OR:
		// OR
		TRACE("Overlap:OR\n");
		iplOr(srcA, srcB, dst);
		break;

	case Cpeg::MODE_XOR:
		// XOR
		TRACE("Overlap:XOR\n");
		iplXor(srcA, srcB, dst);
		break;

	case Cpeg::MODE_NOT:
		// NOT
		TRACE("Overlap:NOT\n");
		iplNot(srcA, dst);
		break;

	case Cpeg::MODE_IMUL:
		// rbg]ďZ
		TRACE("Overlap:]Z\n");
		iplNot(srcA, srcA);
		iplMultiplyScale(srcA, srcB, dst);
		break;

	case Cpeg::MODE_SCRN:
		TRACE("Overlap:XN[\n");
		// ꂼrbg]ďZʂ𔽓]
		iplNot(srcA, srcA);
		iplNot(srcB, srcB);
		iplMultiplyScale(srcA, srcB, dst);
		iplNot(dst, dst);
		iplNot(srcB, srcB); // srcB͌ɖ߂ƁB
		break;

	case Cpeg::MODE_DIV: 
		// Ă
		TRACE("Overlap:Ă\n");
		div(srcA,srcB,dst);
		TRACE("OverlapĂ\n");
		break;

	case Cpeg::MODE_IDIV: 
		// Ă
		TRACE("Overlap:Ă\n");
		idiv(srcA,srcB,dst);
		TRACE("Overlap:Ă\n");
		break;

	case Cpeg::MODE_DARK:
		// rF
		TRACE("Overlap:rF\n");
		dark(srcA,srcB,dst);
		TRACE("Overlap:rF\n");
		break;

	case Cpeg::MODE_LITE:
		// rF
		TRACE("Overlap:rF\n");
		lite(srcA,srcB,dst);
		TRACE("Overlap:rF\n");
		break;

	case Cpeg::MODE_LUM: 
		// Px
		TRACE("Overlap:PxF\n");
		lum(srcA,srcB,dst);
		TRACE("Overlap:PxF\n");
		break;

	case Cpeg::MODE_OVER:
	case Cpeg::MODE_HLIT: 
	case Cpeg::MODE_SLIT: 
	case Cpeg::MODE_DIFF: 
	case Cpeg::MODE_EXCU:

		/// ȉ͖Ή[h
	case Cpeg::MODE_DISS:
	case Cpeg::MODE_HUE: 
	case Cpeg::MODE_SAT: 
	case Cpeg::MODE_COLR: 
		// Ή
		TRACE("Overlap:Ή[h=%d\n", mode);
		break;
	default:
		// s
		TRACE("Overlap:sȃ[h=%d\n", mode);
	}
}

// Ă
/*
 = 255 - (( 255 -  ) * 255 /  ))
A = 0 ̏ꍇy  < 0 ̏ꍇA = 0
ʁAA 0`1͈̔͂ƂꍇA
 = 1 - ( 1 -  ) / 
*/
void IplUtil::div(IplImage * srcA, IplImage * srcB, IplImage * dst)
{
	int loopx, loopy, x, y;
	loopx = __min(srcA->width,  srcB->width);
	loopy = __min(srcA->height, srcB->height);
	//IplImage *tmpI = iplCloneImage(srcB);
	switch(srcB->depth){
	case IPL_DEPTH_8U:
		for(y=0; y<loopy; y++){
			unsigned char* Apixel=(unsigned char*)(srcA->imageData +y * srcA->widthStep);
			unsigned char* Bpixel=(unsigned char*)(srcB->imageData +y * srcB->widthStep);
			unsigned char* wpixel=(unsigned char*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				unsigned short a,b,d;
				a = (unsigned short)(*Apixel);
				b = (unsigned short)(*Bpixel);
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				a = *Apixel;
				b = *Bpixel;
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				a = *Apixel;
				b = *Bpixel;
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				Bpixel++;
				Apixel++;
				wpixel++;
			}
		}
		break;
	case IPL_DEPTH_16U:
		/*
		iplSubtractS(srcB, tmpI, 65535, true);
		//srcA(dst) = srcB/tmpI
		for(y=0; y<loopy; y++){
			unsigned short* Bpixel=(unsigned short*)(srcB->imageData +y * srcB->widthStep);
			unsigned short* rpixel=(unsigned short*)(tmpI->imageData +y * tmpI->widthStep);
			unsigned short* wpixel=(unsigned short*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				Bpixel+=4;
				wpixel+=4;
				rpixel+=4;
			}
		}
		break;
		*/
	default:
		;
	}
	//iplDeallocate(tmpI,IPL_IMAGE_ALL);
}

// Ă ʁMAX/(MAX-) @MAX𒴂ȂB
// srcA 
// srcB 
// dst  (=)
void IplUtil::idiv(IplImage * srcA, IplImage * srcB, IplImage * dst)
{
	int loopx, loopy, x, y;
	loopx = __min(srcA->width,  srcB->width);
	loopy = __min(srcA->height, srcB->height);
	//IplImage *tmpI = iplCloneImage(srcB);
	switch(srcB->depth){
	case IPL_DEPTH_8U:
		for(y=0; y<loopy; y++){
			unsigned char* Apixel=(unsigned char*)(srcA->imageData +y * srcA->widthStep);
			unsigned char* Bpixel=(unsigned char*)(srcB->imageData +y * srcB->widthStep);
			unsigned char* wpixel=(unsigned char*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				unsigned short a,b,d;
				a = (unsigned short)(*Apixel);
				b = (unsigned short)(*Bpixel);
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				a = *Apixel;
				b = *Bpixel;
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				a = *Apixel;
				b = *Bpixel;
				if(a < 255){
					d=(b*255) / (255-a);
					*wpixel = __min(d, 255);
				}else{
					// /(255-255)
					*wpixel = (unsigned char)b;
				}
				Apixel ++;
				Bpixel ++;
				wpixel ++;

				Bpixel++;
				Apixel++;
				wpixel++;
			}
		}
		break;
	case IPL_DEPTH_16U:
		/*
		iplSubtractS(srcB, tmpI, 65535, true);
		//srcA(dst) = srcB/tmpI
		for(y=0; y<loopy; y++){
			unsigned short* Bpixel=(unsigned short*)(srcB->imageData +y * srcB->widthStep);
			unsigned short* rpixel=(unsigned short*)(tmpI->imageData +y * tmpI->widthStep);
			unsigned short* wpixel=(unsigned short*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				*wpixel = __max(*Bpixel / *rpixel, 65535);
				Bpixel+=4;
				wpixel+=4;
				rpixel+=4;
			}
		}
		break;
		*/
	default:
		;
	}
	//iplDeallocate(tmpI,IPL_IMAGE_ALL);
}

// rF
void IplUtil::dark(IplImage * srcA, IplImage * srcB, IplImage * dst)
{
	int loopx, loopy, x, y;
	loopx = __min(srcA->width,  srcB->width);
	loopy = __min(srcA->height, srcB->height);
	switch(srcB->depth){
	case IPL_DEPTH_8U:
		for(y=0; y<loopy; y++){
			unsigned char* Apixel=(unsigned char*)(srcA->imageData +y * srcA->widthStep);
			unsigned char* Bpixel=(unsigned char*)(srcB->imageData +y * srcB->widthStep);
			unsigned char* wpixel=(unsigned char*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				*wpixel++ = __min(*Apixel++, *Bpixel++); //B
				*wpixel++ = __min(*Apixel++, *Bpixel++); //R
				*wpixel++ = __min(*Apixel++, *Bpixel++); //G
				// Alpha͕ςȂ
				Bpixel++;
				Apixel++;
				wpixel++;
			}
		}
		break;
	case IPL_DEPTH_16U:
		TRACE("16bit Ή\n");
	default:
		;
	}

}

// rF
void IplUtil::lite(IplImage * srcA, IplImage * srcB, IplImage * dst)
{
	int loopx, loopy, x, y;
	loopx = __min(srcA->width,  srcB->width);
	loopy = __min(srcA->height, srcB->height);
	switch(srcB->depth){
	case IPL_DEPTH_8U:
		for(y=0; y<loopy; y++){
			unsigned char* Apixel=(unsigned char*)(srcA->imageData +y * srcA->widthStep);
			unsigned char* Bpixel=(unsigned char*)(srcB->imageData +y * srcB->widthStep);
			unsigned char* wpixel=(unsigned char*)(dst->imageData +y * dst->widthStep);
			for(x=0; x<loopx; x++){
				*wpixel++ = __max(*Apixel++, *Bpixel++); //B
				*wpixel++ = __max(*Apixel++, *Bpixel++); //R
				*wpixel++ = __max(*Apixel++, *Bpixel++); //G
				// Alpha͕ςȂ
				Bpixel++;
				Apixel++;
				wpixel++;
			}
		}
		break;
	case IPL_DEPTH_16U:
		TRACE("16bit Ή\n");
	default:
		;
	}

}

// Px
void IplUtil::lum(IplImage * srcA, IplImage * srcB, IplImage * dst)
{
	int loopx, loopy, x, y;
	loopx = __min(srcA->width,  srcB->width);
	loopy = __min(srcA->height, srcB->height);
	IplImage *yuvA = AllocIplYUV(srcA->width, srcA->height, srcA->depth);
	IplImage *yuvB = AllocIplYUV(srcB->width, srcB->height, srcB->depth);
	iplRGB2YUV(srcA, yuvA);
	iplRGB2YUV(srcB, yuvB);

	switch(yuvB->depth){
	case IPL_DEPTH_8U:
		for(y=0; y<loopy; y++){
			unsigned char* Apixel=(unsigned char*)(yuvA->imageData +y * yuvA->widthStep);
			unsigned char* Bpixel=(unsigned char*)(yuvB->imageData +y * yuvB->widthStep);
			for(x=0; x<loopx; x++){
				*Bpixel++ = *Apixel; //Y
				// ͕̑ςȂ
				Bpixel+=3;
				Apixel+=3;
			}
		}
		break;
	case IPL_DEPTH_16U:
		TRACE("16bit Ή\n");
	default:
		;
	}

	iplRGB2YUV(yuvB, dst); // 傫Ⴄꍇł̂E

	iplDeallocate(yuvA,IPL_IMAGE_ALL);
	iplDeallocate(yuvB,IPL_IMAGE_ALL);

}

// XN[ƃY[
// img... 摜.͂Əo͂˂.傫ς邱Ƃ(ʂ͏sx,syɂȂ)
// sx,sy. ʉ摜̃TCY(=Ipl4Piecȇ傫)
// mx,my... ړ
// zoom.. g嗦 100%ȂȂɂȂ 50%Ȃ甼ɏk 200%ȂQ{Ɋg
// tile.. false:Ԃ𖄂߂Ȃ true:Ԃ^Cɖ߂B
IplImage* IplUtil::ScrollZoom(IplImage *img, int sx, int sy, double mx, double my, double zoom, BOOL tile, double scaleX, double scaleY)
{
	// ړ傫̕ωȂΉȂ
	if(mx==0 && my==0 && zoom==100 && scaleX==100 && scaleY==100){
		TRACE("ړgȂ\n");
		return img;
	}
	// 0%ȉɏk摜͏
	if(zoom<=0 || scaleX<=0 || scaleY<=0){
		TRACE("Oȉɏk %f %f %f\n",zoom,scaleX,scaleY);
		FillAlpha(img, 0); //Sʓ
		return img;
	}


	// scaleX,Y k͐ɍsB
	if(scaleX<100){
		if(scaleY<100){
			// X,Yɏk
			int cutwidth = (int)(img->width  * scaleX/100 + 0.5);
			int cutheight= (int)(img->height * scaleY/100 + 0.5);
			IplImage* tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
			iplResizeAll(img, tmpimg, IPL_INTER_SUPER); // ۂɏk
			//tmpimg̍ɏkC[W쐬ꂽBimĝׂʒuɈړĊ
			double dmx = (img->width  - cutwidth)/2;
			double dmy = (img->height - cutheight)/2;
			ScrollCut2(tmpimg, img, dmx, dmy, tile); // ͂ߍ tmpimg(0,0)->img(mx,my)
		}else{
			// X̂ݏk
			int cutwidth = (int)(img->width  * scaleX/100 + 0.5);
			IplImage* tmpimg = AllocIpl(cutwidth, img->height, img->depth);
			iplResizeAll(img, tmpimg, IPL_INTER_SUPER); // ۂɏk
			//tmpimg̍ɏkC[W쐬ꂽBimĝׂʒuɈړĊ
			double dmx = (img->width  - cutwidth)/2;
			ScrollCut2(tmpimg, img, dmx, 0, tile); // ͂ߍ tmpimg(0,0)->img(mx,my)
		}
	}
	if(scaleY<100){
		if(scaleX>=100){
			// Ŷݏk
			int cutheight= (int)(img->height * scaleY/100 + 0.5);
			IplImage* tmpimg = AllocIpl(img->width, cutheight, img->depth);
			iplResizeAll(img, tmpimg, IPL_INTER_SUPER); // ۂɏk
			//tmpimg̍ɏkC[W쐬ꂽBimĝׂʒuɈړĊ
			double dmy = (img->height - cutheight)/2;
			ScrollCut2(tmpimg, img, 0, dmy, tile); // ͂ߍ tmpimg(0,0)->img(mx,my)
		}
	}


	IplImage *tmpimg=NULL; //XN[Đ؂o摜
	int cutwidth  = sx;
	int cutheight = sy;
	if(zoom > 100){
		// g
		cutwidth = (int)(sx * 100/zoom + 0.5);
		cutheight= (int)(sy * 100/zoom + 0.5);
		TRACE("sx=%d sy=%d zoom=%f scalex=%f scaley=%f cutwidth=%d, cutheight=%d\n",sx,sy,zoom,scaleX,scaleY, cutwidth,cutheight);
		tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
		// ZOOḾA؂oJnʒu(mx,my)ɂe^
		// g啪E
		mx += (sx - cutwidth)/2;
		my += (sy - cutheight)/2;
		TRACE("zoom.big mx=%f my=%f\n",mx,my);
		if(cutwidth > img->width || cutheight > img->height){
			Clear(tmpimg);
			ScrollCut2(img,tmpimg,-mx,-my, tile); // ͂ߍ img(0,0)->tmpimg(mx,my)
		}else{
			ScrollCut(img, tmpimg, mx, my, tile); // img(mx,my)->tmpimg(0,0)ɐ؂o
		}
#ifdef _DEBUG
		//fobO
		//iplWriteBmp2(tmpimg, ".\\tmpimgBIGC.bmp", ".\\tmpimgBIGA.bmp");
#endif

		TRACE("ScrollZoom.last resize\n");
		iplDeallocate(img,IPL_IMAGE_ALL);
		img = AllocIpl(sx, sy, tmpimg->depth);
		iplResizeAll(tmpimg, img, IPL_INTER_CUBIC); // ۂɊg
#ifdef _DEBUG
		//fobO
		//iplWriteBmp2(img, ".\\imgBIGC.bmp", ".\\imgBIGA.bmp");
#endif
		TRACE("ScrollZoom.after resize x=%d y=%d image=%x\n",img->width, img->height, img->imageData);
		iplDeallocate(tmpimg,IPL_IMAGE_ALL);
	}else if(zoom < 100){
		// k
		//cutwidth = (int)(sx * zoom/100 + 0.5);
		//cutheight= (int)(sy * zoom/100 + 0.5);
		cutwidth = (int)(img->width  * zoom/100 + 0.5);
		cutheight= (int)(img->height * zoom/100 + 0.5);
		TRACE("sx=%d sy=%d zoom=%f cutwidth=%d, cutheight=%d\n",sx,sy,zoom, cutwidth,cutheight);
		tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
		iplResizeAll(img, tmpimg, IPL_INTER_SUPER); // ۂɏk
		//tmpimg̍ɏkC[W쐬ꂽBimĝׂʒuɈړĊ

		// ZOOḾA͂ߍވʒu(mx,my)ɂe^
		// kS
		TRACE("mx=%f my=%f\n",mx,my);
		//mx += (sx - cutwidth)/2;
		//my += (sy - cutheight)/2;
		mx += (img->width  - cutwidth)/2;
		my += (img->height - cutheight)/2;

		TRACE("ScrollCut2:tmp width=%d height=%d, img width=%d height=%d\n",
			tmpimg->width, tmpimg->height,
			img->width, img->height);
		
		if(cutwidth>sx || cutheight>sy){
			// kĂ܂AʑŜ傫ꍇ
			TRACE("SCROLLZOOM ܂傫 %f %f\n",mx,my);
			ScrollCut(tmpimg, img, -mx, -my, tile); // img(mx,my)->tmpimg(0,0)ɐ؂o
		}else{
			TRACE("SCROLLZOOM2 ʂ菬");
			ScrollCut2(tmpimg, img, mx, my, tile); // ͂ߍ tmpimg(0,0)->img(mx,my)
		}
#ifdef _DEBUG
		//fobO
		//iplWriteBmp2(tmpimg, ".\\tmpimgSMALLC.bmp", ".\\tmpimgSMALLA.bmp"); //
		//iplWriteBmp2(img, ".\\imgSMALLC.bmp", ".\\imgSMALLA.bmp"); // F^
#endif
		iplDeallocate(tmpimg,IPL_IMAGE_ALL);
	}else{
		// Y[ȂBړ̂
		tmpimg = AllocIpl(sx, sy, img->depth);
		ScrollCut(img, tmpimg, mx, my, tile);
		iplDeallocate(img,IPL_IMAGE_ALL);
		img = tmpimg;
	}

	// scaleX,Y g͌ɍsB
	if(scaleX>100){
		if(scaleY>100){
			// X,YɊg
			cutwidth = (int)(sx * 100/scaleX + 0.5);
			cutheight= (int)(sy * 100/scaleY + 0.5);
			TRACE("sx=%d sy=%d zoom=%f scalex=%f scaley=%f cutwidth=%d, cutheight=%d\n",sx,sy,zoom,scaleX,scaleY, cutwidth,cutheight);
			tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
			mx = (sx - cutwidth)/2;
			my = (sy - cutheight)/2;
			TRACE("zoom.big mx=%f my=%f\n",mx,my);
			if(cutwidth > img->width || cutheight > img->height){
				Clear(tmpimg);
				ScrollCut2(img,tmpimg,-mx,-my, tile); // ͂ߍ img(0,0)->tmpimg(mx,my)
			}else{
				ScrollCut(img, tmpimg, mx, my, tile); // img(mx,my)->tmpimg(0,0)ɐ؂o
			}

			TRACE("ScrollZoom.last resize\n");
			iplDeallocate(img,IPL_IMAGE_ALL);
			img = AllocIpl(sx, sy, tmpimg->depth);
			iplResizeAll(tmpimg, img, IPL_INTER_CUBIC); // ۂɊg
			iplDeallocate(tmpimg,IPL_IMAGE_ALL);
		}else{
			// X̂݊g
			TRACE("X̂݊g\n");
			cutwidth = (int)(sx * 100/scaleX + 0.5);
			cutheight= sy;
			TRACE("sx=%d sy=%d zoom=%f scalex=%f scaley=%f cutwidth=%d, cutheight=%d\n",sx,sy,zoom,scaleX,scaleY, cutwidth,cutheight);
			tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
			mx = (sx - cutwidth)/2;
			my = 0;
			TRACE("zoom.big mx=%f my=%f\n",mx,my);
			if(cutwidth > img->width || cutheight > img->height){
				Clear(tmpimg);
				ScrollCut2(img,tmpimg,-mx,-my, tile); // ͂ߍ img(0,0)->tmpimg(mx,my)
			}else{
				ScrollCut(img, tmpimg, mx, my, tile); // img(mx,my)->tmpimg(0,0)ɐ؂o
			}

			TRACE("ScrollZoom.last resize\n");
			iplDeallocate(img,IPL_IMAGE_ALL);
			img = AllocIpl(sx, sy, tmpimg->depth);
			iplResizeAll(tmpimg, img, IPL_INTER_CUBIC); // ۂɊg
			iplDeallocate(tmpimg,IPL_IMAGE_ALL);
		}
	} 
	if(scaleY>100){
		if(scaleX<=100){
			// Ŷ݊g
			TRACE("Ŷ݊g\n");
			cutwidth = sx;
			cutheight= (int)(sy * 100/scaleY + 0.5);
			TRACE("sx=%d sy=%d zoom=%f scalex=%f scaley=%f cutwidth=%d, cutheight=%d\n",sx,sy,zoom,scaleX,scaleY, cutwidth,cutheight);
			tmpimg = AllocIpl(cutwidth, cutheight, img->depth);
			mx = 0;
			my = (sy - cutheight)/2;
			TRACE("zoom.big mx=%f my=%f\n",mx,my);
			if(cutwidth > img->width || cutheight > img->height){
				Clear(tmpimg);
				ScrollCut2(img,tmpimg,-mx,-my, tile); // ͂ߍ img(0,0)->tmpimg(mx,my)
			}else{
				ScrollCut(img, tmpimg, mx, my, tile); // img(mx,my)->tmpimg(0,0)ɐ؂o
			}
			TRACE("ScrollZoom.last resize\n");
			iplDeallocate(img,IPL_IMAGE_ALL);
			img = AllocIpl(sx, sy, tmpimg->depth);
			iplResizeAll(tmpimg, img, IPL_INTER_CUBIC); // ۂɊg
			iplDeallocate(tmpimg,IPL_IMAGE_ALL);
		}
	}

	return img;
}

// _Bsrc(mx,my)dst̕؂o
// src ... Qƌ
// dst ... ؂oʊi[
// mx,my .. ړʁsrc̓ǂݏoʒuB_ȉB
// tile ... TRUE:^C FALSE:Ȃ
// PDF͂S̃uh(n̓x͖POO)Ō܂
// QDx́ASZB
void IplUtil::ScrollCut(IplImage* src, IplImage* dst, double mx, double my, BOOL tile)
{
	int axl, axr, ayl, ayr; // l=؂̂ r= ؂グ
	double asx, asy; //1dot ȉ̍
	int l_MAX; //ől
	if(src->depth == IPL_DEPTH_8U){
		l_MAX = 255;
	}else{
		l_MAX = 65535;
	}
	
	axl=(int)floor(mx); // ؂̂ā@
	ayl=(int)floor(my);
	asx=fabs(fmod(mx, 1)); //ƉE̍ij
	asy=fabs(fmod(my, 1));
	axr=(int)ceil(mx); //؂グ@E
	ayr=(int)ceil(my);
	
	//Sɕďd˂
	double n2,n3,n4; //ꂼ̔Zxv͂P
	n2 = asx*asy; // (axl,ayl)
	n3 = asy - n2; //(1-asx)*asy; (arx,aly)
	n4 = asx - n2; //asx*(1-asy); (alx,ary)
	//	n1 = 1-n2-n3-n4; //(1-asx)*(1-asy); (axr,ayr)
	
	unsigned int msk1, msk2, msk3, msk4;
	
	msk2 = (unsigned int)(n2 * l_MAX); // Zx(char)
	msk3 = (unsigned int)(n3 * l_MAX); // Zx(char)
	msk4 = (unsigned int)(n4 * l_MAX); // Zx(char)
	msk1 = (unsigned int)(l_MAX - msk2 - msk3 - msk4); // Zx(char)
	
	TRACE("A axl=%d, ayl=%d, axr=%d, ayr=%d, asx=%f asy=%f, msk1=%d() msk2=%d(%f), msk3=%d(%f), msk4=%d(%f)\n",
		axl, ayl, axr, ayr, asx, asy, msk1, msk2,n2, msk3,n3, msk4,n4
		);

	// ʉʏ
	iplSet(dst, 0); // F
	FillAlpha(dst, l_MAX); // (ŌimgalphaŒu)

	// [NGA
	IplImage* imgcolor; // Fp[NB1/4ɔ߂srcC[W
	imgcolor = AllocIpl(src->width, src->height, src->depth);

	// [NGA
	IplImage* imgalpha; // 4Zʂ̃lێpB
	imgalpha = AllocIpl(imgcolor->width, imgcolor->height, imgcolor->depth);
	FillAlpha(imgalpha,0); // 
	IplROI *roi;
	roi = iplCreateROI(4, 0, 0, imgalpha->width, imgalpha->height); //4Ԗڂ̃`l(=)ɃtH[JX
	imgalpha->roi=roi;

	// wAxɐ؂̂Ă̈ʒu
	if(msk1 != 0){
		// F 1/4ɔ߂Fuh
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8( src, imgcolor, axl, ayl, msk1); // src̐FRs[msk1̓x
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;

		TRACE("END1\n");
	}
	// wAxɐ؂グ̈ʒu
	if(msk2 != 0){
		// F 1/4ɔ߂Fuh
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8( src, imgcolor, axr, ayr, msk2);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	if(msk3 != 0){
		// F 1/4ɔ߂Fuh
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8( src, imgcolor, axr, ayl, msk3);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	if(msk4 != 0){
		// F 1/4ɔ߂Fuh
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8( src, imgcolor, axl, ayr, msk4);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	dst->roi=roi;
	iplCopy(imgalpha, dst);
	dst->roi=NULL;
	iplDeleteROI(roi);
	iplDeallocate(imgcolor,IPL_IMAGE_ALL);
	TRACE("ScrollCut Done\n");
}

// kłgȂ
// _Bsrc(0,0)dst(mx,my)ֈړďd˂B
// src ... Qƌ
// dst ... ʊi[
// mx,my .. ړʁdstւ̏oʒuB_ȉB
// tile ... TRUE:^C FALSE:Ȃ
// PDF͂S̃uh(n̓x͖POO)Ō܂
// QDx́ASZB
void IplUtil::ScrollCut2(IplImage* src, IplImage* dst, double mx, double my, BOOL tile)
{
	int axl, axr, ayl, ayr; // l=؂̂ r= ؂グ
	double asx, asy; //1dot ȉ̍
	int l_MAX; //ől
	if(src->depth == IPL_DEPTH_8U){
		l_MAX = 255;
	}else{
		l_MAX = 65535;
	}
	
	axl=(int)floor(mx); // ؂̂ā@
	ayl=(int)floor(my);
	asx=fabs(fmod(mx, 1)); //ƉE̍ij
	asy=fabs(fmod(my, 1));
	axr=(int)ceil(mx); //؂グ@E
	ayr=(int)ceil(my);
	
	//Sɕďd˂
	double n2,n3,n4; //ꂼ̔Zxv͂P
	n2 = asx*asy; // (axl,ayl)
	n3 = asy - n2; //(1-asx)*asy; (arx,aly)
	n4 = asx - n2; //asx*(1-asy); (alx,ary)
	//	n1 = 1-n2-n3-n4; //(1-asx)*(1-asy); (axr,ayr)
	
	unsigned int msk1, msk2, msk3, msk4;
	
	msk2 = (unsigned int)(n2 * l_MAX); // Zx(char)
	msk3 = (unsigned int)(n3 * l_MAX); // Zx(char)
	msk4 = (unsigned int)(n4 * l_MAX); // Zx(char)
	msk1 = (unsigned int)(l_MAX - msk2 - msk3 - msk4); // Zx(char)
	
	TRACE("A axl=%d, ayl=%d, axr=%d, ayr=%d, asx=%f asy=%f, msk1=%d() msk2=%d(%f), msk3=%d(%f), msk4=%d(%f)\n",
		axl, ayl, axr, ayr, asx, asy, msk1,msk2,n2, msk3,n3, msk4,n4
		);

	// ʉʏ
	iplSet(dst, 0); // F
	FillAlpha(dst, l_MAX); // (ŌimgalphaŒu)

	// [NGA
	IplImage* imgcolor; // Fp[NB1/4ɔ߂srcC[W
	imgcolor = AllocIpl(dst->width, dst->height, dst->depth);

	// [NGA
	IplImage* imgalpha; // 4Zʂ̃lێpB
	imgalpha = AllocIpl(imgcolor->width, imgcolor->height, imgcolor->depth);
	FillAlpha(imgalpha,0); // 
	IplROI *roi;
	roi = iplCreateROI(4, 0, 0, imgalpha->width, imgalpha->height); //4Ԗڂ̃`l(=)ɃtH[JX
	imgalpha->roi=roi;

	// wAxɐ؂̂Ă̈ʒu
	if(msk1 != 0){
		// F 1/4ɔ߂Fuh
		//iplCopy(src, imgcolor); // FRs[
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8T( src, imgcolor, axl, ayl, msk1);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;

		TRACE("END1\n");
	}
	// wAxɐ؂グ̈ʒu
	if(msk2 != 0){
		// F 1/4ɔ߂Fuh
		//iplCopy(src, imgcolor); // FRs[
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8T( src, imgcolor, axr, ayr, msk2);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	if(msk3 != 0){
		// F 1/4ɔ߂Fuh
		//iplCopy(src, imgcolor); // FRs[
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8T( src, imgcolor, axr, ayl, msk3);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	if(msk4 != 0){
		// F 1/4ɔ߂Fuh
		//iplCopy(src, imgcolor); // FRs[
		imgcolor->roi=roi;
		src->roi = roi;
		iplCopy(src, imgcolor);
		imgcolor->roi=NULL;
		src->roi = NULL;
		iplMovOvw8T( src, imgcolor, axl, ayr, msk4);
		iplAlphaComposite(imgcolor,dst,dst, IPL_COMPOSITE_OVER, NULL,NULL,NULL, TRUE, FALSE);

		//  iplMovOvw81/4ɔ߂̂Z邾
		imgcolor->roi=roi;
		iplAdd(imgcolor,imgalpha, imgalpha);
		imgcolor->roi=NULL;
	}
	dst->roi=roi;
	iplCopy(imgalpha, dst);
	dst->roi=NULL;
	iplDeleteROI(roi);
	iplDeallocate(imgcolor,IPL_IMAGE_ALL);
	TRACE("ScrollCut2 Done\n");
}


// Rs[
// src ... ؂o
// dst ... \t
// sx,sy ... src̐؂oʒu
// dx,dy ... dst̓\tʒu 
// width,height ... 傫
void IplUtil::BlockCopy(IplImage * src, IplImage * dst, int sx, int sy, int dx, int dy, int width, int height)
{
	if(sx<0 || sy<0 || dx<0 || dy<0 || width<0 || height<0){
		return;
	}
	if(sx > src->width || sy > src->height || dx > dst->width || dy > dst->height){
		return;
	}

	int loopx, loopy;
	loopx=width;
	loopy=height;
	if(sx+loopx > src->width){
		loopx=src->width-sx;
	}
	if(sy+loopy > src->height){
		loopy=src->height-sy;
	}
	if(dx+loopx > dst->width){
		loopx=dst->width-sx;
	}
	if(dy+loopy > dst->height){
		loopy=dst->height-sy;
	}

	char pixel[8]; //MAX32biẗ̗
	for(int y=0; y<loopy; y++){
		for(int x=0; x<loopx; x++){
			iplGetPixel(src, sx+x, sy+y,(void*)pixel);
			iplPutPixel(dst, dx+x, dy+y,(void*)pixel);
		}
	}
}

// 摜Ŝ width*height̓eŖߐs
void IplUtil::TilingFill(IplImage * img, int width, int height)
{
	TRACE("TilngFill x=%d y=%d width=%d height=%d\n",
		img->width, img->height, width, height);
	if(img->width > width){
		TRACE("TilingFill:X loop\n");
		int lx = (img->width/width)-1; // [v
		for(int x=1; x<=lx; x++){
			BlockCopy(img, img, 0,0, x*width,0, width, height);
		}
	}
	if(img->height > height){
		TRACE("TilingFill:Y loop\n");
		int ly = (img->height/height)-1; // [v
		for(int y=1; y<=ly; y++){
			BlockCopy(img, img, 0,0, 0,y*height, img->width, height);
		}
	}
}


//BGRÃC[W32bitBMPt@Cɏo
int IplUtil::iplWriteBmp(IplImage *p_img, CString filename)
{
	LPBITMAPINFOHEADER bif3;
	BITMAPFILEHEADER bmphead;		// t@Cwb_[
	int datalen;
	int ret=0;
	IplImage* img=NULL;
	CFile a_fp;	// ̧߲
	CFileException a_err;

	char msg[256];
	sprintf(msg,"iplWriteBmp:Error.Filename=%s ",filename);

	if(p_img == NULL){
		strcat(msg,"C[Wwb_NULL");
		OutMsg(msg);
		return -5;
	}

	if(memcmp(p_img->colorModel, "RGBA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->colorModel,4);
		tmp[4]=0;
		strcat(msg,"J[fRGBAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -1;
	}

	if(memcmp(p_img->channelSeq, "BGRA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->channelSeq,4);
		tmp[4]=0;
		strcat(msg,"J[V[PXBGRAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -2;
	}

	if(p_img->imageData == NULL){
		strcat(msg,"C[Wf[^NULL");
		OutMsg(msg);
		return -3;
	}

	if(p_img->depth != IPL_DEPTH_8U){
		TRACE("F[x=%d convert\n",p_img->depth);
		img=AllocIpl(p_img->width, p_img->height,IPL_DEPTH_8U);
		iplScale(p_img,img);
	}else{
		img = p_img;
	}

	int width = img->width * 4;
	width += (4-(width % 4));
	datalen = (sizeof(BITMAPINFOHEADER) + width * img->height);
	bif3 = (LPBITMAPINFOHEADER)malloc(datalen);

	bif3->biSize = sizeof(BITMAPINFOHEADER);
	bif3->biWidth = img->width;
	bif3->biHeight = img->height;
	bif3->biPlanes = 1;
	bif3->biBitCount = 32;
	bif3->biCompression = 0;
	bif3->biSizeImage = 0;
	bif3->biClrUsed = 0;

	iplConvertToDIB(img, bif3, 1, 1);

//	GFileWritePNG(bif3, filename+".PNG", 0); // BMPnPNGŏރeXgp

//	TWAIN_WriteNativeToFilename(hnd3, file3);

	memcpy(&bmphead.bfType , "BM", 2);
	bmphead.bfSize = datalen;
	bmphead.bfReserved1 =0;
	bmphead.bfReserved2 =0;
	bmphead.bfOffBits = 54;

	TRY
	{
		a_fp.Open(filename, CFile::modeCreate|CFile::modeWrite, &a_err );
		a_fp.Write(&bmphead, sizeof(BITMAPFILEHEADER)); // t@Cwb_[
		a_fp.Write(bif3,  datalen);		// alo
		a_fp.Close();
	}

	CATCH( CFileException, a_err)
	{
		switch(a_err->m_cause){
		case CFileException::fileNotFound:
			ret= -100;
	        strcat(msg,"̧ق܂");
			OutMsg(msg);
			break;
		case CFileException::badPath:
			ret = -101;
	        strcat(msg,"߽sł");
			OutMsg(msg);
			break;
		case CFileException::hardIO:
			ret = -102;
	        strcat(msg,"ʰ޳װ");
			OutMsg(msg);
			break;
		default:
			ret = -103;
	        strcat(msg,"̑װ");
			OutMsg(msg);
		}		
	}
	END_CATCH

	free(bif3);
	if(img != p_img){
		iplDeallocate(img,IPL_IMAGE_ALL);
	}

	return ret;
}

//BGRÃC[WTARGA32t@Cɏo Compress=0=k 1=k
int IplUtil::iplWriteTga(IplImage *p_img, CString filename, int compress)
{
	TGAHEAD tgahead;	// Targawb_[
	TGAEXT	tgaext;		// Targa 2.0瓧xɕKv
	TGAFOOT tgafoot;	// Targa 2.0Kv
	IplImage *img;
	int ret=0;

	CFile a_fp;	// ̧߲
	CFileException a_err;

	char msg[256];
	sprintf(msg,"iplWriteTga:Error.Filename=%s ",filename);

	if(p_img == NULL){
		strcat(msg,"C[Wwb_NULL");
		OutMsg(msg);
		return -5;
	}

	if(memcmp(p_img->colorModel, "RGBA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->colorModel,4);
		tmp[4]=0;
		strcat(msg,"J[fRGBAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -1;
	}

	if(memcmp(p_img->channelSeq, "BGRA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->channelSeq,4);
		tmp[4]=0;
		strcat(msg,"J[V[PXBGRAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -2;
	}

	if(p_img->imageData == NULL){
		strcat(msg,"C[Wf[^");
		OutMsg(msg);
		return -3;
	}

	if(p_img->depth != IPL_DEPTH_8U){
		TRACE("F[x=%d convert\n",p_img->depth);
		img=AllocIpl(p_img->width, p_img->height,IPL_DEPTH_8U);
		iplScale(p_img,img);
	}else{
		img=p_img;
	}

	memset(&tgahead, 0, sizeof(TGAHEAD));
	memset(&tgaext,  0, sizeof(TGAEXT));
	memset(&tgafoot, 0, sizeof(TGAFOOT));

	if(compress==0){
		tgahead.Image_Type = 2;/* 2=kRGB^Cv */
	}else{
		tgahead.Image_Type = 10;/* 10=kRGB^Cv */
	}
	tgahead.Width = img->width;	/*  (dot)*/
	tgahead.Height = img->height;	/*  (dot)*/
	tgahead.Pixel = 32;	/* Pixel Size. 32=32bit */
	tgahead.IDesc_Type = 8;	/* 8=TGA32 Agr[g */

	tgaext.len = 457;  /* ̃GNXeVGA̒ 495Œ */
//	tgaext.author[41];     /* Җ(ASCII NULL STOPK{ gȂȂ0Ŗ߂鎖*/
//	tgaext.comment[81][4]; /* ҂̃Rg(80oCgNULLKv) gȂȂ0Ŗ߂鎖*/
//	tgaext.job[41];        /* d (Җɓ)*/
	strcpy(tgaext.soft, "tms2avi");       /* \tgEFAID (Җɓ) */
	tgaext.verNunber=100;     /* o[Wio[ * 100(1.01Ȃ101) gȂȂ0Ŗ߂鎖*/
	tgaext.verLot = 'A';         /* bg(ASCII) gȂȂXy[XZbg*/
	tgaext.att_type = 3; /* 0:f[^Ȃ 1,2:f[^ 3:`lL 4:pre-multipliedȃf[^ */

	tgafoot.Ext_Ofs = sizeof(TGAHEAD) + img->imageSize; /* t@C擪AGNXeVGA܂ł̃oCg*/
	memcpy(tgafoot.Sign, "TRUEVISION-XFILE", 16);/* Œ */
	tgafoot.RFU1='.';   /* "."Œ */
	tgafoot.RFU2=0;   /* NULL.0 Œ */

	TRY
	{
		a_fp.Open(filename, CFile::modeCreate|CFile::modeWrite, &a_err );
		a_fp.Write(&tgahead, sizeof(TGAHEAD));
		if(compress == 0){
			a_fp.Write(img->imageData,  img->imageSize);	//̂܂܏
		}else{
			int i, rleCount;
			char *packBuff, *srcBuff;
			packBuff = (char*)malloc( img->width*(4+1) );
			srcBuff = img->imageData;
			for(i=0; i<img->height; i++){
				rleCount= RLEncodeRow(srcBuff, packBuff, img->width, 4);
				a_fp.Write(packBuff,  rleCount);
				srcBuff += img->width*4;
			}
			free(packBuff);
		}
		a_fp.Write(&tgaext,  sizeof(TGAEXT));
		a_fp.Write(&tgafoot, sizeof(TGAFOOT));
		a_fp.Close();
	}

	CATCH( CFileException, a_err)
	{
		switch(a_err->m_cause){
		case CFileException::fileNotFound:
			ret = -100;
	        strcat(msg,"̧ق܂");
			OutMsg(msg);
			break;
		case CFileException::badPath:
			ret = -101;
	        strcat(msg,"߽sł");
			OutMsg(msg);
			break;
		case CFileException::hardIO:
			ret = -102;
	        strcat(msg,"ʰ޳װ");
			OutMsg(msg);
			break;
		default:
			ret = -103;
	        strcat(msg,"̑װ");
			OutMsg(msg);
			break;
		}		
	}
	END_CATCH

	if(p_img != img){
		iplDeallocate(img,IPL_IMAGE_ALL);
	}

	return ret;
}

int IplUtil::RLEncodeRow( char *p,char *q, int n, int bpp)
{
	int				diffCount;		/* pixel count until two identical */
	int				sameCount;		/* number of identical adjacent pixels */
	int				RLEBufSize;		/* count of number of bytes encoded */

	RLEBufSize = 0;
	while ( n > 0 )
	{
		diffCount = CountDiffPixels( p, bpp, n );
		sameCount = CountSamePixels( p, bpp, n );
		if ( diffCount > 128 ) diffCount = 128;
		if ( sameCount > 128 ) sameCount = 128;
		if ( diffCount > 0 )
		{
			/* create a raw packet */
			*q++ = (char)(diffCount - 1);
			n -= diffCount;
			RLEBufSize += (diffCount * bpp) + 1;
			while ( diffCount > 0 )
			{
				*q++ = *p++;
				if ( bpp > 1 ) *q++ = *p++;
				if ( bpp > 2 ) *q++ = *p++;
				if ( bpp > 3 ) *q++ = *p++;
				diffCount--;
			}
		}
		if ( sameCount > 1 )
		{
			/* create a RLE packet */
			*q++ = (char)((sameCount - 1) | 0x80);
			n -= sameCount;
			RLEBufSize += bpp + 1;
			p += (sameCount - 1) * bpp;
			*q++ = *p++;
			if ( bpp > 1 ) *q++ = *p++;
			if ( bpp > 2 ) *q++ = *p++;
			if ( bpp > 3 ) *q++ = *p++;
		}
	}
	return( RLEBufSize );
}

/*
** Count pixels in buffer until two identical adjacent ones found
*/

int IplUtil::CountDiffPixels( char *p, int bpp, int pixCnt)
{
	unsigned long	pixel;
	unsigned long	nextPixel;
	int				n;

	n = 0;
	if ( pixCnt == 1 ) return( pixCnt );
	pixel = GetPixel( p, bpp );
	while ( pixCnt > 1 )
	{
		p += bpp;
		nextPixel = GetPixel( p, bpp );
		if ( nextPixel == pixel ) break;
		pixel = nextPixel;
		++n;
		--pixCnt;
	}
	if ( nextPixel == pixel ) return( n );
	return( n + 1 );
}

int IplUtil::CountSamePixels( char *p, int bpp, int pixCnt)
{
	unsigned long	pixel;
	unsigned long	nextPixel;
	int				n;

	n = 1;
	pixel = GetPixel( p, bpp );
	pixCnt--;
	while ( pixCnt > 0 )
	{
		p += bpp;
		nextPixel = GetPixel( p, bpp );
		if ( nextPixel != pixel ) break;
		++n;
		--pixCnt;
	}
	return( n );
}

/*
** Retrieve a pixel value from a buffer.  The actual size and order
** of the bytes is not important since we are only using the value
** for comparisons with other pixels.
*/
unsigned long IplUtil::GetPixel( char *pp, int bpp)
{
	unsigned long	pixel;
	unsigned char *p;
	p = (unsigned char *)pp;

	pixel = (unsigned long)*p++;
	while ( bpp-- > 1 )
	{
		pixel <<= 8;
		pixel |= (unsigned long)*p++;
	}
	return( pixel );
}

// fobOpBFƓxʁXBMPt@Cɏo
// filename:F̃t@C
// filename2:x̃t@C
int IplUtil::iplWriteBmp2(IplImage *p_img, CString filename, CString filename2)
{
	LPBITMAPINFOHEADER bif3;
	BITMAPFILEHEADER bmphead;		// t@Cwb_[
	int datalen;
	int y;
	int ret=0;
	IplImage *img;
//	char tmp[80];

	CFile a_fp;	// ̧߲
	CFileException a_err;

	char msg[256];
	sprintf(msg,"iplWriteBmp2:Error.Filename=%s ",filename);

	if(p_img == NULL){
		strcat(msg,"C[Wwb_NULL");
		OutMsg(msg);
		return -5;
	}

	if(memcmp(p_img->colorModel, "RGBA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->colorModel,4);
		tmp[4]=0;
		strcat(msg,"J[fRGBAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -1;
	}

	if(memcmp(p_img->channelSeq, "BGRA", 4) != 0){
		char tmp[5];
		memcpy(tmp,p_img->channelSeq,4);
		tmp[4]=0;
		strcat(msg,"J[V[PXBGRAłȂ:");
		strcat(msg,tmp);
		OutMsg(msg);
		return -2;
	}

	if(p_img->imageData == NULL){
		strcat(msg,"iplWriteBmp2:f[^܂");
		OutMsg(msg);
		return -3;
	}

	if(p_img->depth != IPL_DEPTH_8U){
		TRACE("F[x=%d convert\n",p_img->depth);
		img=AllocIpl(p_img->width, p_img->height,IPL_DEPTH_8U);
		iplScale(p_img,img);
	}else{
		img=p_img;
	}

	// x
	int width = img->width;
	width += (img->width%4 == 0)?0:(4 - (img->width % 4)); //SŊ؂ꂽAȂ
//sprintf(tmp, "w1=%d w2=%d h=%d", img->width, width, img->height);
//AfxMessageBox(tmp);
	datalen = (sizeof(BITMAPINFOHEADER) + 256*sizeof(RGBQUAD) + width * img->height );
	bif3 = (LPBITMAPINFOHEADER)malloc(datalen);

	bif3->biSize = sizeof(BITMAPINFOHEADER);
	bif3->biWidth = img->width;
	bif3->biHeight = img->height;
	bif3->biPlanes = 1;
	bif3->biBitCount = 8;		// QTUF
	bif3->biCompression = 0;
	bif3->biSizeImage = 0;
	bif3->biClrUsed = 0;

	// pbg쐬()
	LPRGBQUAD pal = (LPRGBQUAD)((char*)bif3 + bif3->biSize);
	int i;
	for(i=0;i<256;i++){
		pal->rgbBlue = i;
		pal->rgbGreen = i;
		pal->rgbRed = i;
		pal->rgbReserved = i;
		pal ++;
	}

	// `lRs[
	char *top = (char*)bif3 + bif3->biSize;
	top += (sizeof(RGBQUAD) * 256);
	char *dst = top;
	char *src = (char*)(img->imageData);
	src += 3; //`lw
	for(y=0; y<img->height; y++){
		dst  = top;
		dst += width * y;
		for(i=0; i<img->width; i++){
			*dst = *src;
			dst ++;
			src += 4;
		}
	}
	memcpy(&bmphead.bfType , "BM", 2);
	bmphead.bfSize = datalen;
	bmphead.bfReserved1 =0;
	bmphead.bfReserved2 =0;
	bmphead.bfOffBits = sizeof(BITMAPFILEHEADER) +
						sizeof(BITMAPINFOHEADER) +
						sizeof(RGBQUAD) * 256;
	bmphead.bfSize = bmphead.bfOffBits + bif3->biSizeImage;

	TRY
	{
		a_fp.Open(filename2, CFile::modeCreate|CFile::modeWrite, &a_err );
		a_fp.Write(&bmphead, sizeof(BITMAPFILEHEADER)); // t@Cwb_[
		a_fp.Write(bif3,  datalen);		// alo
		a_fp.Close();
	}
	CATCH( CFileException, a_err)
	{
		switch(a_err->m_cause){
		case CFileException::fileNotFound:
			strcat(msg,"t@C܂");
			OutMsg(msg);
			break;
		case CFileException::badPath:
			strcat(msg,"pXsłB");
			OutMsg(msg);
			break;
		case CFileException::hardIO:
			strcat(msg,"n[h̏ł");
			OutMsg(msg);
			break;
		default:
			strcat(msg,"̑G[");
			OutMsg(msg);
			break;
		}		
	}
	END_CATCH

	free(bif3);

	// F
	width = img->width * 3;
	width += (img->width%4 == 0) ? 0:(4-(img->width%4)); //SŊ؂ꂽAȂ
//	width += (4-(img->width%4));
//	width += 4;
	datalen = (sizeof(BITMAPINFOHEADER) + (width+4) * img->height);//Ȃ̂ŁAƂ肠s̒{S
	bif3 = (LPBITMAPINFOHEADER)malloc(datalen);

	bif3->biSize = sizeof(BITMAPINFOHEADER);
	bif3->biWidth = img->width;
	bif3->biHeight = img->height;
	bif3->biPlanes = 1;
	bif3->biBitCount = 24;
	bif3->biCompression = 0;
	bif3->biSizeImage = 0;
	bif3->biClrUsed = 0;

	iplConvertToDIB(img, bif3, 1, 1);

	memcpy(&bmphead.bfType , "BM", 2);
	bmphead.bfSize = datalen;
	bmphead.bfReserved1 =0;
	bmphead.bfReserved2 =0;
	bmphead.bfOffBits = 54;
// char tmp[80];
// sprintf(tmp, "BF=%d, BIF=%d, datalen=%d", sizeof(bmphead), sizeof(BITMAPINFOHEADER),datalen);
// AfxMessageBox(tmp);
	TRY
	{
		a_fp.Open(filename, CFile::modeCreate|CFile::modeWrite, &a_err );
		a_fp.Write(&bmphead, sizeof(BITMAPFILEHEADER)); // t@Cwb_[
		a_fp.Write(bif3,  datalen);		// alo
		a_fp.Close();
	}
	CATCH( CFileException, a_err)
	{
		switch(a_err->m_cause){
		case CFileException::fileNotFound:
			strcat(msg,"t@C܂");
			OutMsg(msg);
			break;
		case CFileException::badPath:
			strcat(msg,"pXsłB");
			OutMsg(msg);
			break;
		case CFileException::hardIO:
			strcat(msg,"n[h̏ł");
			OutMsg(msg);
			break;
		default:
			strcat(msg,"̑G[");
			OutMsg(msg);
			break;
		}		
	}
	END_CATCH

	free(bif3);
	if(img != p_img){
		iplDeallocate(img,IPL_IMAGE_ALL);
	}
	return ret;
}

// `l̓`l킴킴w肵ȂResizeȂ̂Œ
// ̃Iy[VlB
void IplUtil::iplResizeAll(IplImage * src, IplImage * dst, int interpolate)
{
	// F
	iplResize(src, dst, dst->width, src->width, dst->height, src->height, interpolate);
	IplROI *roi,*tmproi;

	// `l(4ԖڌŒ)
	roi    = iplCreateROI(4, 0, 0, dst->width,    dst->height); //4Ԗڂ̃`l(=)ɃtH[JX
	tmproi = iplCreateROI(4, 0, 0, src->width, src->height); //4Ԗڂ̃`l(=)ɃtH[JX
	dst->roi=roi;
	src->roi=tmproi;
	iplResize(src, dst, dst->width, src->width, dst->height, src->height, interpolate);
	dst->roi=NULL;
	src->roi=NULL;
	iplDeleteROI(roi);
	iplDeleteROI(tmproi);
	return;
}


// G[o
void IplUtil::OutMsg(char *txt)
{
	char head[256];
	strcpy(head,"IplUtil:");
	strcat(head,txt);
	if(m_msg != NULL){
		m_msg->out(head);
	}else{
		int len=strlen(head);
		if(head[len-1] != '\n')
			strcat(head,"\n");
		TRACE(head);
	}
}

void IplUtil::setOutMsg(COutMsg * p_msg)
{
	m_msg = p_msg;
}

// F̋Eŉ
// f[^̕тBGRAO
int IplUtil::Border(IplImage *img, int len)
{
	int ret;
	if(img->depth == IPL_DEPTH_8U){
		TRACE("Boerder:8bit\n");
		ret = Border8(img, len);
	}else{
		TRACE("Boerder:16bit\n");
		//ret = Border16(img, len);
		
	}
	return ret;
}

// 8bit
int IplUtil::Border8(IplImage *img, int len){
	struct t_bgra{
		char b;
		char g;
		char r;
		char a;
	};
	int x,y,i;
	DWORD	*readP, *writeP, fill;
	int flg; // 0=sFT 1=FT
	int count; //Thbg
//	char tmp[80];

	if(memcmp(img->colorModel, "RGBA", 4) != 0){
		TRACE("NOT RGBA");
		return -1;
	}

	if(memcmp(img->channelSeq, "BGRA", 4) != 0){
		TRACE("NOT BGRA");
		return -2;
	}

	if(img->imageData == NULL){
		TRACE("NULL");
		return -3;
	}

	// o͐
	IplImage* imgf=AllocIpl(img->width, img->height, img->depth);
	Clear(imgf);

	// ɉ
	readP  = (DWORD*)(img->imageData);
	writeP = (DWORD*)(imgf->imageData);
	for(y=0; y<img->height; y++){
		flg = 1; // ǂłǁAƂ肠sFT
		count=0;
		for(x=0; x<img->width; x++){
			if( ((t_bgra*)(readP))->a == 0 ){ 
				// F
				if(flg == 0){
					// FTĂ
					if(x > 0){ // ÔƂ̃K[h
						fill = *(readP-1);		// O̐F
//						fill = 0x00ffffff;		//F	
						((t_bgra*)&fill)->a=0;	//xO
						*(writeP) = fill;		//𖄂߂
						for(i=1; (i<len) && ( x+i <= img->width ); i++){
							if(((t_bgra*)(readP+i))->a != 0){
								break;	// OsFɂԂ܂ő
							}
							*(writeP+i) = fill;		//𖄂߂
						}	
						x += i;
						readP  += i;
						writeP += i;
					}
					flg=1; //͕sFT
				}
			}else{
				fill = *(readP);		//F	
				((t_bgra*)&fill)->a=0;	//xO
				if(flg == 1){
					// sFTĂ
					for(i=1; (i<len) && (x-i >= 0); i++){
						if(((t_bgra*)(readP-i))->a != 0){
							break;	// sFɂԂ܂
						}
						*(writeP-i) = fill;
					}
					flg=0; //͓FT
				}
			}
			readP ++;
			writeP++;
		}
	}
//	return 0;

	// c
	for(x=0; x<img->width; x++){
		writeP = (DWORD*)(imgf->imageData);
		readP =  (DWORD*)(img->imageData);
		writeP += x; // 
		readP += x; // 
		for(y=0; y<img->height; y++){
			if( *writeP != 0 || ((t_bgra*)(readP))->a != 0){
				// s
				if(((t_bgra*)(readP))->a != 0){
					fill = *(readP);		//F
				}else{
					fill = *(writeP);		//F	
				}
				((t_bgra*)&fill)->a=0;	//xO
				if(flg == 1){
					// sFTĂ
					for(i=1; (i<len) && (y-i >= 0); i++){
						if( *(writeP-i*img->width) != 0 || ( (t_bgra*)( readP-(i*img->width) ) )->a != 0 ){
							break;	// sFɂԂ܂
						}
						*(writeP-i*img->width) = fill;
					}
					flg=0; //͓FT
				}
			}else{
				// F(^)
				//sprintf(tmp, "T(%d,%d,%x)",x,y,*writeP);
				//TRACE(tmp);
				if(flg == 0){
					// FTĂ
					if(y > 0){ // ÔƂ̃K[h
						if(*(writeP-(img->width))!=0){
							fill = *(writeP-(img->width));		// O̐F
						}else{
							fill = *(readP -(img->width));		// O̐F
						}
						((t_bgra*)&fill)->a=0;	//xO
						*(writeP) = fill;		//𖄂߂
						for(i=1; (i<len) && (y+i <= img->height); i++){
							if( *(writeP+(i*img->width)) != 0 || ( (t_bgra*)( readP+(i*img->width) ) )->a != 0 ){
								break;	// sF({)ɂԂ܂
							}
							*(writeP+(i*img->width)) = fill;
						}
						writeP+=i*img->width;
						readP +=i*img->width;
						y+=i;
					}
					flg=1; //͕sFT
				}
			}
			writeP += img->width;
			readP += img->width;
		}
	}

	//@摜d˂B
	IplROI *save_roi;
	save_roi = img->roi;
	img->roi = NULL;
	iplAdd(img,imgf,img);
	img->roi = save_roi;

	iplDeallocate(imgf, IPL_IMAGE_ALL);
	return 0;
}

// 16bit
int IplUtil::Border16(IplImage *img, int len){
	struct t_bgra16{
		short b;
		short g;
		short r;
		short a;
	};
	int x,y,i;
	t_bgra16	*readP, *writeP, fill;
	int flg; // 0=sFT 1=FT
	int count; //Thbg
//	char tmp[80];

	if(memcmp(img->colorModel, "RGBA", 4) != 0){
		TRACE("NOT RGBA");
		return -1;
	}

	if(memcmp(img->channelSeq, "BGRA", 4) != 0){
		TRACE("NOT BGRA");
		return -2;
	}

	if(img->imageData == NULL){
		TRACE("NULL");
		return -3;
	}

	// o͐
	IplImage* imgf=AllocIpl(img->width, img->height, img->depth);
	Clear(imgf);

	// ɉ
	readP  = (t_bgra16*)(img->imageData);
	writeP = (t_bgra16*)(imgf->imageData);
	for(y=0; y<img->height; y++){
		flg = 1; // ǂłǁAƂ肠sFT
		count=0;
		for(x=0; x<img->width; x++){
			if( (readP)->a == 0 ){ 
				// F
				if(flg == 0){
					// FTĂ
					if(x > 0){ // ÔƂ̃K[h
						fill = *(readP-1);		// O̐F
//						fill = 0x00ffffff;		//F	
						fill.a=0;	//xO
						*(writeP) = fill;		//𖄂߂
						for(i=1; (i<len) && ( x+i <= img->width ); i++){
							if((readP+i)->a != 0){
								break;	// OsFɂԂ܂ő
							}
							*(writeP+i) = fill;		//𖄂߂
						}	
						x += i;
						readP  += i;
						writeP += i;
					}
					flg=1; //͕sFT
				}
			}else{
				fill = *(readP);		//F	
				fill.a=0;	//xO
				if(flg == 1){
					// sFTĂ
					for(i=1; (i<len) && (x-i >= 0); i++){
						if( (readP-i)->a != 0){
							break;	// sFɂԂ܂
						}
						*(writeP-i) = fill;
					}
					flg=0; //͓FT
				}
			}
			readP ++;
			writeP++;
		}
	}
//	return 0;

	// c
	for(x=0; x<img->width; x++){
		writeP = (t_bgra16*)(imgf->imageData);
		readP =  (t_bgra16*)(img->imageData);
		writeP += x; // 
		readP += x; // 
		for(y=0; y<img->height; y++){
			if( writeP->r != 0 || writeP->g !=0 || writeP->b != 0 || readP->a != 0){
				// s
				if(readP->a!=0){
					fill = *(readP);		//F
				}else{
					fill = *(writeP);		//F	
				}
				fill.a=0;	//xO
				if(flg == 1){
					// sFTĂ
					for(i=1; (i<len) && (y-i >= 0); i++){
						if( (readP-i*img->width)->a != 0 || (writeP-i*img->width)->r != 0 || (writeP-i*img->width)->g != 0 ||(writeP-i*img->width)->b != 0	){
							break;	// sFɂԂ܂
						}
						*(writeP-i*img->width) = fill;
					}
					flg=0; //͓FT
				}
			}else{
				// F(^)
				//sprintf(tmp, "T(%d,%d,%x)",x,y,*writeP);
				//TRACE(tmp);
				if(flg == 0){
					// FTĂ
					if(y > 0){ // ÔƂ̃K[h
						if((readP-(img->width))->a !=0){
							fill = *(readP -(img->width));		// O̐F
						}else{
							fill = *(writeP-(img->width));		// O̐F
						}
						fill.a=0;	//xO
						*(writeP) = fill;		//𖄂߂
						for(i=1; (i<len) && (y+i <= img->height); i++){
							if( (writeP+(i*img->width))->r != 0 || (writeP+(i*img->width))->g != 0 || (writeP+(i*img->width))->b != 0 || ( readP+(i*img->width) )->a != 0 ){
								break;	// sF({)ɂԂ܂
							}
							*(writeP+(i*img->width)) = fill;
						}
						writeP+=i*img->width;
						readP +=i*img->width;
						y+=i;
					}
					flg=1; //͕sFT
				}
			}
			writeP += img->width;
			readP += img->width;
		}
	}

	//@摜d˂B
	IplROI *save_roi;
	save_roi = img->roi;
	img->roi = NULL;
	iplAdd(img,imgf,img);
	img->roi = save_roi;

	iplDeallocate(imgf, IPL_IMAGE_ALL);
	return 0;
}


// ʊORGB`FbNAOȊOȂ烿lMAXɃZbg
// len:t`̌hbg
void IplUtil::BorderAlpha(IplImage * img, int len)
{
//	len ++;
	if(img->depth == IPL_DEPTH_8U){
		BorderAlpha8(img, len);
	}else{
		BorderAlpha16(img, len);
	}
}

void IplUtil::BorderAlpha8(IplImage * img, int len)
{
	int x,y;
	unsigned char pixel[64];
	unsigned char a;

	// 
	for(y=len; y>=0; y--){
		for(x=0; x<img->width; x++){
			iplGetPixel(img, x, y+1, (void*)pixel);
			if( pixel[3]!=0){
				a=pixel[3];
//				if(y==2)
//					TRACE("BorderAlpha8:Hit x=%d y=%d a=%d\n",x,y,a);
				iplGetPixel(img, x, y, (void*)pixel);
				pixel[3]=a;
				iplPutPixel(img, x, y, (void*)pixel);
			}
//			else{
//				if(y==2)
//					TRACE("BorderAlpha8:NO Hit x=%d y=%d a=%d\n",x,y,pixel[3]);
//			}
		}
		if(x!= img->width)
			TRACE("Invalid x=%d y=%d\n", x,y);
		else
			TRACE("OK x=%d y=%d\n",x,y);
	}

	// 
	for(y=0; y<img->height; y++){
		for(x=len; x>=0; x--){
			iplGetPixel(img, x+1, y, (void*)pixel);
			if( pixel[3]!=0){
				a=pixel[3];
				iplGetPixel(img, x, y, (void*)pixel);
				pixel[3]=a;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

	// E
	for(y=0; y<img->height; y++){
		for(x=img->width-len-1; x<img->width; x++){
			iplGetPixel(img, x-1, y, (void*)pixel);
			if(pixel[3]!=0){
				a=pixel[3];
				iplGetPixel(img, x, y, (void*)pixel);
				pixel[3]=a;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

	// 
	for(y=img->height-len-1; y<img->height; y++){
		for(x=0; x<img->width; x++){
			iplGetPixel(img, x, y-1, (void*)pixel);
			if(pixel[3]!=0){
				a=pixel[3];
				iplGetPixel(img, x, y, (void*)pixel);
				pixel[3]=a;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

}

void IplUtil::BorderAlpha16(IplImage * img, int len)
{
	int x,y;
	unsigned short pixel[8];

	// 
	for(y=0; y<len; y++){
		for(x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[0]!=0x00 || pixel[1]!=0x00 || pixel[2]!=0x00){
				pixel[3]=65535;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

	// 
	for(y=0; y<img->height; y++){
		for(x=0; x<len; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[0]!=0x00 || pixel[1]!=0x00 || pixel[2]!=0x00){
				pixel[3]=65535;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

	// E
	for(y=0; y<img->height; y++){
		for(x=img->width-len; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[0]!=0x00 || pixel[1]!=0x00 || pixel[2]!=0x00){
				pixel[3]=65535;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}

	// 
	for(y=img->height-len; y<img->height; y++){
		for(x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[0]!=0x00 || pixel[1]!=0x00 || pixel[2]!=0x00){
				pixel[3]=65535;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}
}

// ۑp摜쐬B
// lOŁARGBOȊOȂA͉BlőlɂB
// ̑̓lOɂB
void IplUtil::makeSaveBorder(IplImage * img)
{
	if(img->depth == IPL_DEPTH_8U){
		makeSaveBorder8(img);
	}else{
		makeSaveBorder16(img);
	}
}

// 쐬ς݂̉摜(imgflame)RGBimgɔfB
// imgflamẽ0ȊOȂARGB㏑
void IplUtil::useSaveBorder(IplImage * imgflame, IplImage * img)
{
	if(img->depth == IPL_DEPTH_8U){
		useSaveBorder8(imgflame, img);
	}else{
		useSaveBorder16(imgflame, img);
	}
}

// ȉ̊֐͕pɂɎĝŃAZu\(\肾)

// CPUʏ
#define __cpuid        __asm __emit 0Fh __asm __emit 0A2h
#pragma warning(disable:4035)
int IplUtil::CPU() {
	int flags=0,type=0;
	__asm {
		xor eax,eax;
		__cpuid;
		or eax,eax;
		jz quit;
		mov eax,1;
		__cpuid;
		mov flags,edx;
	quit:
	}
	if (flags&(1<<31)) {
		type|=cpu_3dnow;
		if (flags&(1<<30)) {
			type|=cpu_e3dnow;
		}
	}

	if (flags&(1<<23)) {
		type|=cpu_mmx;
		if (flags&(1<<25)) {
			type|=cpu_sse;
			if (flags&(1<<26)) {
				type|=cpu_sse2;
			}
		}
	}
	return type;

	/**********************
	99.09.29.19.06 x[
	ubTDOł cpuid ăT|[gĂȂłˁB

	#define __cpuid        __asm __emit 0Fh __asm __emit 0A2h

	#pragma warning(disable:4035)
	bool CanUseMMX()
	{
		__asm
		{
		    mov     eax, 1
		    __cpuid
		    xor      eax, eax   // ̍s͕svibool ̃TCY͂PoCgƎv̂Łj
		    bt        edx, 23
		    setc    al
		}
	    return;
	}
	#pragma warning(default:4035)

	ƂɃn[hR[fBOKv̂ŁAubTDOgĂl͎QlɂĉB
	***********/
}
#pragma warning(default:4035)

// ɂ
// img͖{NXAllocIpl()ŃAP[g`O
void IplUtil::Clear(IplImage * img)
{
	iplSet(img,0);
	FillAlpha(img, 0); //Sʓ
}

// ɂ
// img͖{NXAllocIpl()ŃAP[g`O
void IplUtil::ClearBlack(IplImage * img)
{
	int l_MAX;
	if(img->depth == IPL_DEPTH_8U){
		l_MAX = 255;
	}else{
		l_MAX = 65535;
	}

	iplSet(img, 0); // F
	FillAlpha(img, l_MAX); // 
}

// src(axl,ayl)dst(0,0)src-ax̑傫Rs[BZx͂P
int IplUtil::iplMovOvw8( IplImage *src, IplImage *dst,  int axl, int ayl, int mask)
{
	int cwidth,chight;
	//struct t_rgba work, *from, *to;
	int fx,fy;

	// Workp̈NAB
	iplSet(dst,0);
	FillAlpha(dst,0);
	//memset(dst->imageData,0,dst->imageSize);
	
	// ړRs[
	fx = MAX(0, axl);
	fy = MAX(0, ayl);
	cwidth  = src->width - abs(axl);
	chight  = src->height - abs(ayl);

	TRACE("iplMovOvw8 cwidth=%d chight=%d\n",cwidth,chight);

	////////////////////// 3/17Ɏɒǉ傫`FbN //////////////////////
	if(cwidth > dst->width){
		cwidth=dst->width;
		TRACE("iplMovOvw8 cwidth cut. %d\n",cwidth);
	}
	if(chight > dst->height){
		chight = dst->height;
		TRACE("iplMovOvw8 chight cut. %d\n",chight);
	}
	////////////////////// 3/17Ɏɒǉ傫`FbN //////////////////////


	// Jnʒu}CiX
	int tx,ty;
	tx=0;
	ty=0;
	if(axl<0){
		tx = abs(axl);
	}
	if(ayl<0){
		ty = abs(ayl);
	}

	int step;
	if(src->depth == IPL_DEPTH_8U){
		step = 4;
	}else{
		step = 8;
	}
	for(int y=0; y<chight; y++){
		/*
		for(int x=0; x<cwidth; x++){
			char pixel[8]; //MAX64biẗ̗
			iplGetPixel(src, fx+x, fy+y, (void*)pixel);
			iplPutPixel(dst, tx+x, ty+y, (void*)pixel);
		}
		*/
		char *from,*to;
		from = src->imageData + (fy+y)*src->widthStep + fx*step;
		to   = dst->imageData + (ty+y)*dst->widthStep + tx*step;
		memcpy(to, from, cwidth*step);
	}

	// x𔖂߂
	if( (src->depth==IPL_DEPTH_8U && mask>=255) || mask >= 65535){
		TRACE("iplMovOvw8:SKIP set\n");
	}else{
		IplROI *roi, *save_roi;
		save_roi=dst->roi;
		roi = iplCreateROI(4, 0, 0, dst->width, dst->height); //4Ԗڂ̃`l(=)ɃtH[JX
		dst->roi=roi;
		iplMultiplySScale(dst, dst, mask);
		dst->roi=save_roi; // NULL܂͌̒l
		iplDeleteROI(roi);
	}
	return 0;
}

// src(0,0)dst(axl,ayl)src̑傫Rs[BZx͂P
int IplUtil::iplMovOvw8T( IplImage *src, IplImage *dst,  int axl, int ayl, int mask)
{
	TRACE("iplMovOvw8T start. stc x=%d y=%d dst x=%d y=%d axl=%d ayl=%d\n",
		src->width, src->height, dst->width, dst->height, axl, ayl);

	int cwidth,chight;
	//struct t_rgba work, *from, *to;
	int tx,ty;
	tx=MAX(0,axl);
	ty=MAX(0,ayl);

	// Workp̈NAB
	iplSet(dst,0);
	FillAlpha(dst,0);
	//memset(dst->imageData,0,dst->imageSize);
	
	// ړRs[
	int fx,fy;
	fx = 0;
	fy = 0;
	// Jnʒu}CiX
	if(axl<0){
		fx = abs(axl);
	}
	if(ayl<0){
		fy = abs(ayl);
	}

	cwidth  = src->width ;
	chight  = src->height;

	if(tx+cwidth >= dst->width){
		cwidth -= (tx+cwidth) - dst->width;
	}
	if(ty+chight >= dst->height){
		chight -= (ty+chight) - dst->height;
	}

	TRACE("iplMovOvw8T cwidth=%d chight=%d fx=%d fy=%d tx=%d ty=%d\n",
		cwidth,chight,fx,fy,tx,ty);

	int step;
	if(src->depth == IPL_DEPTH_8U){
		step = 4;
	}else{
		step = 8;
	}
	for(int y=0; y<chight; y++){
		/*
		for(int x=0; x<cwidth; x++){
			char pixel[8]; //MAX64biẗ̗
			//TRACE("X=%d, tx=%d width=%d\n",x,tx,dst->width);
			iplGetPixel(src, fx+x, fy+y, (void*)pixel);
			iplPutPixel(dst, tx+x, ty+y, (void*)pixel);
		}
		*/
		char *from,*to;
		from = src->imageData + (fy+y)*src->widthStep + fx*step;
		to   = dst->imageData + (ty+y)*dst->widthStep + tx*step;
		memcpy(to, from, cwidth*step);
	}

	// AZu͂炵
	//_asm{
	//	emms
	//}

	// x𔖂߂
	if( (src->depth==IPL_DEPTH_8U && mask>=255) || mask >= 65535){
		TRACE("iplMovOvw8:SKIP set\n");
	}else{
		IplROI *roi, *save_roi;
		save_roi=dst->roi;
		roi = iplCreateROI(4, 0, 0, dst->width, dst->height); //4Ԗڂ̃`l(=)ɃtH[JX
		dst->roi=roi;
		iplMultiplySScale(dst, dst, mask);
		dst->roi=save_roi; // NULL܂͌̒l
		iplDeleteROI(roi);
	}
	return 0;
}



// l͂炸ARGBhԂ
void IplUtil::FillOnlyColor(IplImage * img, int r, int g, int b)
{
	char errmsg[256];
	if(img->nChannels < 4){
		sprintf(errmsg,"FillOnlyColor() C[W`lĂ܂ nCannels=%d\n", img->nChannels);
		OutMsg(errmsg);
		return;
	}

	if(img->depth != IPL_DEPTH_8U){
		r*=256;
		g*=256;
		b*=256;
	}

	IplROI *roi, *save_roi;
	save_roi=img->roi;

	roi = iplCreateROI(1, 0, 0, img->width, img->height); //1Ԗڂ̃`l(=)ɃtH[JX
	img->roi=roi;
	iplSet(img, b); //B
	iplSetROI(roi, 2, 0, 0, img->width, img->height); //2Ԗڂ̃`l(=)ɃtH[JX
	iplSet(img, g); //G
	iplSetROI(roi, 3, 0, 0, img->width, img->height); //3Ԗڂ̃`l(=)ɃtH[JX
	iplSet(img, r); //R

	img->roi=save_roi; // NULL܂͌̒l
	iplDeleteROI(roi);

	return;
}

// 򂵂̑ÔQD݂̍h~
// `lOAARGB0,0,0̕
// `lOARGB͋ߏ̐FAɂB
int IplUtil::AlphaFill(IplImage * img)
{
	int ret;
	int count=10;// ő10
	if(img->depth == IPL_DEPTH_8U){
		while(ret>0 && count >0){
			TRACE("Before AlphaFil8:ret=%d count=%d\n",ret,count);
			ret = AlphaFill8(img);
			count --;
			TRACE("After AlphaFil8:ret=%d count=%d\n",ret,count);
		}
	}else{
		while(ret>0 && count >0){
			ret = AlphaFill16(img);
			count --;
		}
	}
	return ret;
}

// ߂l̂܂܎chbg
int IplUtil::AlphaFill8(IplImage * img)
{
	int ret=0;
	unsigned char l[4],r[4],u[4],d[4]; //F
	unsigned int dl,dr,du,dd,mind; //
	unsigned char pixel[4];// BGRA
	unsigned int intpixel;
	for(int y=0; y<img->height; y++){
		TRACE("width=%d\n",img->width);
		for(int x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)&intpixel);
			if( intpixel == 0){
				// SĂODׂsNZłB
				memset(pixel,0,4);
				dl = searchColorL8(img,x,y,l); 
				dr = searchColorR8(img,x,y,r); 
				du = searchColorU8(img,x,y,u); 
				dd = searchColorD8(img,x,y,d);
				int flg = 0;
				mind=MAX(img->width, img->height)+1;
				if(dl < mind){
					flg = 1;
					memcpy(pixel, &l, 4);
				}
				if(dr < mind){
					flg = 1;
					memcpy(pixel, &r, 4);
				}
				if(du < mind){
					flg = 1;
					memcpy(pixel, &u, 4);
				}
				if(dd < mind){
					flg = 1;
					memcpy(pixel, &d, 4);
				}
				if(flg ==0){
					ret ++;
				}else{
					iplPutPixel(img, x, y, (void*)pixel);
				}
			}
		}
		TRACE("\n--y=%d-----\n",y);
	}
	return ret;
}

// ߂l̂܂܎chbg
int IplUtil::AlphaFill16(IplImage * img)
{
	return 0;
}

// ̈ԋ߂FƂ̋
unsigned int IplUtil::searchColorU8(IplImage *img, int x, int y, unsigned char *pixel)
{
	memset(pixel, 0, 4);
	unsigned int intpixel;
	int ret=0;

	for(int l=y-1; l>0; l--){
		iplGetPixel(img, x, l, (void*)&intpixel);
		if( intpixel != 0){
			memcpy(pixel, &intpixel, 4);
			break;
		}
		ret ++;
	}
	if(l<=0){
		// ݂Ȃ
		ret = MAX(img->width, img->height)+10;
	}
	TRACE("searchColorU8 ret=%d ",ret);
	return ret;
}

unsigned int IplUtil::searchColorD8(IplImage *img, int x, int y, unsigned char *pixel)
{
	memset(pixel, 0, 4);
	unsigned int intpixel;
	int ret=0;

	for(int l=y+1; l<img->height; l++){
		iplGetPixel(img, x, l, (void*)&intpixel);
		if( intpixel != 0){
			memcpy(pixel, &intpixel, 4);
			break;
		}
		ret ++;
	}
	if(l>=img->height){
		// ݂Ȃ
		ret = MAX(img->width, img->height)+10;
	}
	TRACE("searchColorD8 ret=%d ",ret);
	return ret;
}
unsigned int IplUtil::searchColorL8(IplImage *img, int x, int y, unsigned char *pixel)
{
	memset(pixel, 0, 4);
	unsigned int intpixel;
	int ret=0;

	for(int l=x-1; l>0; l--){
		iplGetPixel(img, l, y, (void*)&intpixel);
		if( intpixel != 0){
			memcpy(pixel, &intpixel, 4);
			break;
		}
		ret ++;
	}
	if(l<=0){
		// ݂Ȃ
		ret = MAX(img->width, img->height)+10;
	}
	TRACE("searchColorL8 ret=%d ",ret);
	return ret;
}

unsigned int IplUtil::searchColorR8(IplImage *img, int x, int y, unsigned char *pixel)
{
	memset(pixel, 0, 4);
	unsigned int intpixel;
	int ret=0;

	for(int l=x+1; l<img->width; l++){
		iplGetPixel(img, l, y, (void*)&intpixel);
		if( intpixel != 0){
			memcpy(pixel, &intpixel, 4);
			break;
		}
		ret ++;
	}
	if(l>=img->width){
		// ݂Ȃ
		ret = MAX(img->width, img->height)+10;
	}
	TRACE("searchColorR8 ret=%d ",ret);
	return ret;
}

// 򂵑ȌꍇARGB=0,0,0̃sNZȂB
// 摜ǂݍ݂Ɠ0,0,1ɖύXB
// ǂ򂷂΂ȂB
void IplUtil::ChangeBlack(IplImage * img)
{
	if(img->depth == IPL_DEPTH_8U){
		ChangeBlack8(img);
	}else{
		ChangeBlack16(img);
	}
}

void IplUtil::ChangeBlack8(IplImage * img)
{
	unsigned char pixel[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[3] != 0 &&
				pixel[0] == 0 &&
				pixel[1] == 0 &&
				pixel[2] == 0){
				pixel[0] ++;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}
}

void IplUtil::ChangeBlack16(IplImage * img)
{
	unsigned short pixel[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[3] != 0 &&
				pixel[0] == 0 &&
				pixel[1] == 0 &&
				pixel[2] == 0){
				pixel[0] ++;
				iplPutPixel(img, x, y, (void*)pixel);
			}
		}
	}
}

void IplUtil::makeSaveBorder8(IplImage * img)
{
	unsigned char pixel[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[3] == 0 &&
				pixel[0] != 0 &&
				pixel[1] != 0 &&
				pixel[2] != 0)
			{
				pixel[3] = 255;
			}else{
				memset(pixel, 0, 4);
			}
			iplPutPixel(img, x, y, (void*)pixel);
		}
	}
}

void IplUtil::makeSaveBorder16(IplImage * img)
{
	unsigned short pixel[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(img, x, y, (void*)pixel);
			if( pixel[3] == 0 &&
				pixel[0] != 0 &&
				pixel[1] != 0 &&
				pixel[2] != 0)
			{
				pixel[3] = 65535;
			}else{
				memset(pixel, 0, 8);
			}
			iplPutPixel(img, x, y, (void*)pixel);
		}
	}
}

void IplUtil::useSaveBorder8(IplImage * imgflame, IplImage* img)
{
	unsigned char pixel[4];// BGRA
	unsigned char pixelimg[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(imgflame, x, y, (void*)pixel);
			if( pixel[3] != 0)
			{
				iplGetPixel(img, x, y, (void*)pixelimg);
				memcpy(pixelimg, pixel, 3); //FRs[
				iplPutPixel(img, x, y, (void*)pixelimg);
			}
		}
	}
}

void IplUtil::useSaveBorder16(IplImage * imgflame, IplImage* img)
{
	unsigned short pixel[4];// BGRA
	unsigned short pixelimg[4];// BGRA
	for(int y=0; y<img->height; y++){
		for(int x=0; x<img->width; x++){
			iplGetPixel(imgflame, x, y, (void*)pixel);
			if( pixel[3] != 0)
			{
				iplGetPixel(img, x, y, (void*)pixelimg);
				memcpy(pixelimg, pixel, 6); //FRs[
				iplPutPixel(img, x, y, (void*)pixelimg);
			}
		}
	}
}

