// OfsetWindow.cpp: COfsetWindow NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "CellShade.h"
#include "OfsetWindow.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

COfsetWindow::COfsetWindow()
{

}

COfsetWindow::COfsetWindow(const void *top, RECT rect)
{
	m_rgbtop = (RGBQUAD*)top;
	m_chartop= (char*)top;
	m_rect = rect;
	m_width = rect.right - rect.left;
	m_height= rect.bottom- rect.top;
	blank_rgb.rgbRed = 0;
	blank_rgb.rgbGreen=0;
	blank_rgb.rgbBlue= 0;
	blank_rgb.rgbReserved=0;
	blank_char = 0;
}

COfsetWindow::~COfsetWindow()
{

}

RGBQUAD* COfsetWindow::GetPixel(int px, int py, RGBQUAD* p_blank)
{
	RGBQUAD *ret;
	char msg[256];
	if(p_blank != NULL){
		/**
		sprintf(msg," Return User Default R=%d,G=%d,B=%d A=%d\n",
			p_blank->rgbRed,
			p_blank->rgbBlue,
			p_blank->rgbGreen,
			p_blank->rgbReserved);
		TRACE(msg);
		*/
		ret = p_blank;
	}else{
		/**
		sprintf(msg," Return System Default R=%d,G=%d,B=%d A=%d\n",
			blank_rgb.rgbRed,
			blank_rgb.rgbBlue,
			blank_rgb.rgbGreen,
			blank_rgb.rgbReserved);
		TRACE(msg);
		*/
		ret = &blank_rgb;
	}

	if( px < m_rect.left ||
		px >= m_rect.right ||
		py < m_rect.top ||
		py >= m_rect.bottom){
		sprintf(msg,"GetPixel ͈͊O(%d,%d) (%d,%d)-(%d,%d)\n",
			px,py,
			m_rect.left, m_rect.top,
			m_rect.right, m_rect.bottom);
		TRACE(msg);
		return ret;
	}
	//sprintf(msg,"GetPixel͈͓ (%d,%d) \n",px,py);
	int x = px-m_rect.left;
	int y = py-m_rect.top;

	int add= x + y* m_width;
	if(add > m_width*m_height){
		TRACE("͈͊O(BIG) %d/%d, ",add,m_width*m_height);
		return ret;
	}else if(add < 0){
		TRACE("͈͊O(SMALL) %d/%d, ",add,m_width*m_height);
		return ret;
	}
	ret = m_rgbtop;
	ret += add;
	
	return ret;
}

char * COfsetWindow::GetChar(int px, int py)
{
	char *ret;
	char msg[256];

	if( px < m_rect.left ||
		px >= m_rect.right ||
		py < m_rect.top ||
		py >= m_rect.bottom){
		/*
		sprintf(msg,"GetChar ͈͊O(%d,%d) (%d,%d)-(%d,%d)\n",
			px,py,
			m_rect.left, m_rect.top,
			m_rect.right, m_rect.bottom);
		TRACE(msg);
		*/
		return &blank_char;
	}
	int x = px-m_rect.left;
	int y = py-m_rect.top;

	ret = m_chartop;
	ret += (x + y* m_width);
	
	return ret;
}

int COfsetWindow::PutPixel(int px, int py, RGBQUAD col)
{
	RGBQUAD *ret;
	char msg[256];

	if( px < m_rect.left ||
		px >= m_rect.right ||
		py < m_rect.top ||
		py >= m_rect.bottom){
		/*
		sprintf(msg,"PutPixel ͈͊O(%d,%d) (%d,%d)-(%d,%d)\n",
			px,py,
			m_rect.left, m_rect.top,
			m_rect.right, m_rect.bottom);
		TRACE(msg);
		*/
		return -1;
	}
	int x = px-m_rect.left;
	int y = py-m_rect.top;

	int add= x + y* m_width;
	if(add > m_width*m_height){
		TRACE("͈͊O(BIG) %d/%d, ",add,m_width*m_height);
		return -1;
	}else if(add < 0){
		TRACE("͈͊O(SMALL) %d/%d, ",add,m_width*m_height);
		return -1;
	}

	ret = m_rgbtop;
	ret += add;

	*ret = col;

	return 0;
}

char COfsetWindow::GetAlphaValue(int px, int py)
{
	char ret;
	char msg[256];

	if( px < m_rect.left ||
		px >= m_rect.right ||
		py < m_rect.top ||
		py >= m_rect.bottom){
		/*
		sprintf(msg,"GetAlpha ͈͊O(%d,%d) (%d,%d)-(%d,%d)\n",
			px,py,
			m_rect.left, m_rect.top,
			m_rect.right, m_rect.bottom);
		TRACE(msg);
		*/
		return 0;
	}
	int x = px-m_rect.left;
	int y = py-m_rect.top;

	RGBQUAD *rgba = m_rgbtop;
	rgba += (x + y* m_width);
	ret = rgba->rgbReserved;
	
	return ret;
}

int COfsetWindow::PutAlphaValue(int px, int py, char p_val)
{
	RGBQUAD *ret;
	char msg[256];

	if( px < m_rect.left ||
		px >= m_rect.right ||
		py < m_rect.top ||
		py >= m_rect.bottom){
		/*
		sprintf(msg,"PutAlpha ͈͊O(%d,%d) (%d,%d)-(%d,%d)\n",
			px,py,
			m_rect.left, m_rect.top,
			m_rect.right, m_rect.bottom);
		TRACE(msg);
		*/
		return -1;
	}
	int x = px-m_rect.left;
	int y = py-m_rect.top;

	ret = m_rgbtop;
	ret += (x + y* m_width);

	ret->rgbReserved = p_val;

	return 0;
}

RECT COfsetWindow::GetRect()
{
	return m_rect;
}

RGBQUAD* COfsetWindow::GetRGBtop()
{
	return m_rgbtop;
}
