#ifndef _TLPSDEX_H_
#define _TLPSDEX_H_

#include < windows.h >

#define TLPSD_MAXSTR 68

#define TLPSDERR_NO_ERROR            0
#define TLPSDERR_UNKNOWN             301
#define TLPSDERR_FILE_NOT_OPEN       302
#define TLPSDERR_BROKEN_FILE         303
#define TLPSDERR_ANOTHER_FILE_OPENED 304
#define TLPSDERR_BROKEN_FILEHEADER	 305
#define TLPSDERR_TOO_LARGE_IMAGE     306
#define TLPSDERR_WRONG_COLOR_MODE    307
#define TLPSDERR_WRONG_COLOR_DEPTH   308
#define TLPSDERR_FILE_NOT_OPENED     309
#define TLPSDERR_CANNOT_DECOMPRESS   310
#define TLPSDERR_LAYER_NOT_EXIST     311
#define TLPSDERR_FILE_NOT_WRITTEN    312
#define TLPSDERR_LAYER_TOO_MUCH      313
#define TLPSDERR_BAD_ARGUMENT        314
#define TLPSDERR_LACK_OF_MEMORY      315
#define TLPSDERR_NOTHING_MERGEDIMAGE 316
#define TLPSDERR_NOTHING_ANY_IMAGE   317

#define TLPSDSAVE_RPT_SAVED          203

//-----------------------------------------
#define TLPSDSAVE_ALLOCATE_MEMORY    0X00000001 // default: using memory blocks allocated by application
#define TLPSDSAVE_ALPHA_CHANNEL_ONLY 0X00000002 // default: using user mask
typedef struct tagTLPSD_MESSAGE
{
	HWND   hWnd;
	UINT   uUserMessage;  // WM_APP + N
	WPARAM wpReportMsg;
	WPARAM wpProgress;
	WPARAM wpFinish;
	DWORD  dwFlags;
	LPVOID lParam;
} TLPSD_MESSAGE;
typedef TLPSD_MESSAGE* LPTLPSD_MESSAGE;
//-----------------------------------------

typedef struct tagTLPSD_IMAGE_INFO
{
    int     nIndex;         // Zero-oder layer index. 
    int     nGroup;         // Linkage between layers. If a layer has negative value, the layer has not any linkage. 
    RECT    rcImage;
    char    szName[TLPSD_MAXSTR];
    BOOL    bfVisible;      // TRUE=visible, FLASE=unvisible layer
    char    szBlendMode[8]; // Blend mode key
    int     nOpacity;       // 0=transparent, 0XFF=opaque
    BOOL    bfMaskVisible;  // TRUE=visible, FLASE=unvisible layer
} TLPSD_IMAGE_INFO;
typedef TLPSD_IMAGE_INFO* LPTLPSD_IMAGE_INFO;

typedef int  (CALLBACK* TLPSD_GETVERSION)		 ();
typedef void (CALLBACK* TLDSD_UNDERSCAN)		 (RGBQUAD *lpImage, LPRECT lprcImage, const LPRECT lprcFrame);
typedef void (CALLBACK* TLDSD_MINIMIZE)			 (RGBQUAD *lpImage, LPRECT lprcImage);

typedef int  (CALLBACK* TLPSDLOAD_GETVERSION)	 ();
typedef int  (CALLBACK* TLDSDLOAD_OPEN)          (LPCTSTR lpszFileName, const UINT uMaxImageSize, LPVOID lParam);
typedef void (CALLBACK* TLDSDLOAD_CLOSE)         ();
typedef int  (CALLBACK* TLDSDLOAD_GETLAYERCOUNT) ();
typedef int  (CALLBACK* TLDSDLOAD_GETIMAGEINFO)  (LPTLPSD_IMAGE_INFO lpinfo);
typedef int  (CALLBACK* TLDSDLOAD_GETIMAGE)      (const int nIndex, void *lpvBuffer, const int nBufferSize, LPRECT lpRect);
typedef void (CALLBACK* TLDSDLOAD_UNDERSCAN)	 (RGBQUAD *lpImage, LPRECT lprcImage, const LPRECT lprcFrame);
typedef void (CALLBACK* TLDSDLOAD_MINIMIZE)		 (RGBQUAD *lpImage, LPRECT lprcImage);

typedef int  (CALLBACK* TLPSDSAVE_GETVERSION)    ();
typedef int  (CALLBACK* TLDSDSAVE_OPEN)          (LPCTSTR lpszFileName, int nMaximumLayer, LPTLPSD_MESSAGE lpMsg);
typedef int  (CALLBACK* TLDSDSAVE_CLOSE)         ();
typedef int  (CALLBACK* TLDSDSAVE_SETIMAGE)      (RGBQUAD *pImage, const int nWidth, const int nHeight);
typedef int  (CALLBACK* TLDSDSAVE_SETLAYER)      (RGBQUAD *pImage, const TLPSD_IMAGE_INFO *pInfo);

#endif
